	SUBROUTINE FMAP
C
C       This subroutine can flip the pixel location information in a map 
C  or set of maps, either horizontally, vertically, or both.
C		VERSION 2, B. C. C., 9/10/81
C		ADDED VERSION, SCRATCH_BLOCK, & _SHARE ENTRY
C		Version 3, A. J. P., March 26, 1981
C		Amended to flip horizontally or vertically or
C		to flip in x and y (180 degree rotation)
C		Version 4, Donald H. Gudehus, October, 1983
C		Made user friendly
C		Version 5, Donald H. Gudehus, April, 1993
C		Made more user friendly and incorporated a call to
C		GETMAPS.
C		Version 6, Donald H. Gudehus, May 12, 2008
C		Converted to FITS and Unix.
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*1 COMMAND
	CHARACTER*3 FILEFMT
	CHARACTER*50 CHFITSMHV
	CHARACTER*80 FILENAME_IN
C
	INTEGER STATUS
	INTEGER MAPS_IN(MAPMAX),NCOLS_OUT(MAPMAX),
	1NROWS_OUT(MAPMAX)
C
	REAL*4 DATA(MAXSIZE),DATA2(MAXSIZE),X
C
	REAL*8 DATADP(MAXSIZE),DATA2DP(MAXSIZE),XDP
C
	CALL MESSAGE ('FMAP, Version 6')
C  Open one or more maps in the input file
	LU_IN=11
	FILENAME_IN=' '
	CALL MESSAGE('Open the file to be flipped')
	CALL GET_INPUT_FITS_MAPS(LU_IN,FILENAME_IN,MAPS_IN,NMAPS_IN,STATUS)
	IF (STATUS.NE.0) THEN
	  CALL CLOSEFITS(LU_IN)
	  RETURN
	END IF
C  Create a temporary file.  This allows for several options when we save our
C  results.
	LU_TEMP=12
	DO I=1,NMAPS_IN
	  IM=MAPS_IN(I)
	  NCOLS_OUT(I)=NAXIS1(IM,LU_IN)
	  NROWS_OUT(I)=NAXIS2(IM,LU_IN)
	END DO
	CALL OPEN_TEMP_FITS(LU_IN,LU_TEMP,FILENAME_IN,MAPS_IN,NMAPS_IN,
	1NCOLS_OUT,NROWS_OUT,STATUS)
C
   5	COMMAND='X'
	CALL MESSAGE('Enter a command:')
	CALL MESSAGE('     X = Flips maps in X direction (left to right) '//
	1'(default)')
	CALL MESSAGE('     Y = Flips maps in Y direction (top to bottom)')
	CALL MESSAGE('     R = Flips maps in X and Y (equals 180 deg '//
	1'rotation)')
	CALL USRINP(%REF(COMMAND),1,'A',1,1,'COMMAND=',' ')
	IF (COMMAND.NE.'X'.AND.COMMAND.NE.'Y'.AND.COMMAND.NE.'R') THEN
	  CALL ERROR(-1,'Flip was incorrectly specified in FMAP')
	  GO TO 5
	END IF
C
	DO M=1,NMAPS_IN !  Loop for maps
	  IM=MAPS_IN(M)
	  NI=NCOLS_OUT(M)
	  NJ=NROWS_OUT(M)
	  FILEFMT=CHFITSMHV(LU_IN,IM,'BITPIX','R4')
	  DO IP=1,NAXIS3(M,LU_IN) !  Loop for planes
	    IF (COMMAND.EQ.'X') THEN
	      IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	        DO J=1,NJ !  Loop for rows
	          CALL RDDPFITSROW(LU_IN,IM,IP,DATADP,NI,J)
	          DO I=1,NI !  Loop for columns
	            K=NI-I+1
	            DATA2DP(K)=DATADP(I)
	          END DO
	          CALL WRDPFITSROW(LU_TEMP,IM,IP,DATA2DP,NI,J)
	        END DO
	      ELSE
	        DO J=1,NJ !  Loop for rows
	          CALL RDFITSROW(LU_IN,IM,IP,DATA,NI,J)
	          DO I=1,NI !  Loop for columns
	            K=NI-I+1
	            DATA2(K)=DATA(I)
	          END DO
	          CALL WRFITSROW(LU_TEMP,IM,IP,DATA2,NI,J)
	        END DO
	      END IF
	    ELSE IF (COMMAND.EQ.'Y'.AND.NJ.GT.1) THEN
	      NJ2=NJ/2
	      IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	        DO J=1,NJ2
	          L=NJ-J+1
	          CALL RDDPFITSROW(LU_IN,IM,IP,DATADP,NI,J)
	          CALL RDDPFITSROW(LU_IN,IM,IP,DATA2DP,NI,L)
	          CALL WRDPFITSROW(LU_TEMP,IM,IP,DATADP,NI,L)
	          CALL WRDPFITSROW(LU_TEMP,IM,IP,DATA2DP,NI,J)
	        END DO
C  We don't need to check the central row for odd NJ as in the older version
c	        IF (NJ2.LT.FLOAT(NJ)/2..AND.MAPS_OUT(M).NE.MAPS_IN(M)) THEN
c	          NC=NJ2+1
c	          CALL RDDPFITSROW(LU_IN,IM,IP,DATADP,NI,NC)
c	          CALL WRDPFITSROW(LU_TEMP,IM,IP,DATADP,NI,NC)
c	        END IF
	      ELSE
	        DO J=1,NJ2
	          L=NJ-J+1
	          CALL RDFITSROW(LU_IN,IM,IP,DATA,NI,J)
	          CALL RDFITSROW(LU_IN,IM,IP,DATA2,NI,L)
	          CALL WRFITSROW(LU_TEMP,IM,IP,DATA,NI,L)
	          CALL WRFITSROW(LU_TEMP,IM,IP,DATA2,NI,J)
	        END DO
C  We don't need to check the central row for odd NJ as in the older version
c	        IF (NJ2.LT.FLOAT(NJ)/2..AND.MAPS_OUT(M).NE.MAPS_IN(M)) THEN
c	          NC=NJ2+1
c	          CALL RDFITSROW(LU_IN,IM,IP,DATA,NI,NC)
c	          CALL WRFITSROW(LU_TEMP,IM,IP,DATA,NI,NC)
c	        END IF
	      END IF
	    ELSE IF (COMMAND.EQ.'R'.AND.NI.GE.2.AND.NJ.GE.2) THEN
	      NJ2=NJ/2
	      NI2=NI/2
	      IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	        DO J=1,NJ2
	          L=NJ-J+1
	          CALL RDDPFITSROW(LU_IN,IM,IP,DATADP,NI,J)
	          CALL RDDPFITSROW(LU_IN,IM,IP,DATA2DP,NI,L)
	          DO I=1,NI2
	            K=NI-I+1
	            XDP=DATADP(I)
	            DATADP(I)=DATADP(K)
	            DATADP(K)=XDP
	            XDP=DATA2DP(I)
	            DATA2DP(I)=DATA2DP(K)
	            DATA2DP(K)=XDP
	          END DO
	          CALL WRDPFITSROW(LU_TEMP,IM,IP,DATADP,NI,L)
	          CALL WRDPFITSROW(LU_TEMP,IM,IP,DATA2DP,NI,J)
	        END DO
C  Check the central row for odd NJ
	        IF (NJ2.LT.FLOAT(NJ)/2.0) THEN
	          NC=NJ2+1
	          CALL RDDPFITSROW(LU_IN,IM,IP,DATADP,NI,NC)
	          DO I=1,NI
	            K=NI-I+1
	            DATA2DP(K)=DATADP(I)
	          END DO
	          CALL WRDPFITSROW(LU_TEMP,IM,IP,DATA2DP,NI,NC)
	        END IF
	      ELSE
	        DO J=1,NJ2
	          L=NJ-J+1
	          CALL RDFITSROW(LU_IN,IM,IP,DATA,NI,J)
	          CALL RDFITSROW(LU_IN,IM,IP,DATA2,NI,L)
	          DO I=1,NI2
	            K=NI-I+1
	            X=DATA(I)
	            DATA(I)=DATA(K)
	            DATA(K)=X
	            X=DATA2(I)
	            DATA2(I)=DATA2(K)
	            DATA2(K)=X
	          END DO
	          CALL WRFITSROW(LU_TEMP,IM,IP,DATA,NI,L)
	          CALL WRFITSROW(LU_TEMP,IM,IP,DATA2,NI,J)
	        END DO
C  Check the central row for odd NJ
	        IF (NJ2.LT.FLOAT(NJ)/2.0) THEN
	          NC=NJ2+1
	          CALL RDFITSROW(LU_IN,IM,IP,DATA,NI,NC)
	          DO I=1,NI
	            K=NI-I+1
	            DATA2(K)=DATA(I)
	          END DO
	          CALL WRFITSROW(LU_TEMP,IM,IP,DATA2,NI,NC)
	        END IF
	      END IF
	    ELSE
	      CALL ERROR(-3,'Insufficient rows or columns to be '
	1     //'flipped in FMAP')
	    END IF
	  END DO
	END DO 
C
	LU_OUT=13
	CALL SAVE_SAVE_AS(LU_IN,LU_TEMP,LU_OUT,MAPS_IN,NMAPS_IN,STATUS)
C  The files are closed by the above call to save_save_as.
	RETURN
	END
