	SUBROUTINE GALCOORD
	ENTRY GALCOORD_SHARE
C
C       This subroutine computes either new or old galactic coordinates, 
C  equatorial coordinates, or supergalactic coordinates from the user 
C  supplied coordinates.
C			Donald H. Gudehus, May, 1987
C		Version 2, Donald H. Gudehus, January 31, 1991
C		Added ability to convert to old glactic coordinates
C		and ability to convert to equatorial coordinates.
C		Version 3, Donald H. Gudehus, April, 1991
C		Added conversion between old and new galactic coordinates
C		and put in  call to USRINP_DMS.
C
	LOGICAL MORE
	REAL DEG,MIN,SEC
	REAL*8 DEGREES,MINUTES,SECONDS,DEGREES2,MINUTES2,SECONDS2
	REAL*8 EPOCH1,EPOCH2,LONGITUDEIN,LONGITUDEOUT,LATITUDEIN,LATITUDEOUT,
	1RIGHTASC,DECLINA
	DIMENSION RAPARAM(3)
	COMMON /SCRATCH_BLOCK/ MORE,DEG,MIN,SEC,DEGREES,MINUTES,SECONDS,
	1DEGREES2,MINUTES2,SECONDS2,
	1EPOCH1,EPOCH2,LONGITUDEIN,LONGITUDEOUT,LATITUDEIN,LATITUDEOUT,
	2RIGHTASC,DECLINA,LX,NF,NR
	CHARACTER*1 CSIGN,DUMMY
	CHARACTER*4 COMMAND
	COMMON /CHAR_SCRATCH_BLOCK/ COMMAND,LOCATION,CSIGN,DUMMY
C
	CALL MESSAGE('GALCOORD, Version 3')
	DEGREES=0.0D0
	MINUTES=0.0D0
	SECONDS=0.0D0
	COMMAND=' '
	DO WHILE (COMMAND.NE.'EQNG'.AND.COMMAND.NE.'EQOG'.AND.COMMAND
	1.NE.'NGEQ'.AND.COMMAND.NE.'OGEQ'.AND.COMMAND.NE.'NGOG'
	2.AND.COMMAND.NE.'OGNG'.AND.COMMAND.NE.'NGSG'.AND.COMMAND.NE.
	3'OGSG')
	  CALL MESSAGE('Enter a command:')
	  CALL MESSAGE('     EQNG = Converts equatorial coordinates
	1 to new galactic  (default)')
	  CALL MESSAGE('     EQOG = Converts equatorial coordinates
	1 to old galactic')
	  CALL MESSAGE('     NGEQ = Converts new galactic
	1 coordinates to equatorial')
	  CALL MESSAGE('     OGEQ = Converts old galactic coordinates
	1 to equatorial')
	  CALL MESSAGE('     NGOG = Converts new galactic coordinates to
	1 old galactic coordinates')
	  CALL MESSAGE('     OGNG = Converts old galactic coordinates to
	1 new galactic coordinates')
	  CALL MESSAGE('     NGSG = Converts new galactic coordinates to
	1 supergalactic coordinates')
	  CALL MESSAGE('     OGSG = Converts old galactic coordinates to
	1 supergalactic coordinates')
	  COMMAND='EQNG'
	  CALL USRINP(%REF(COMMAND),1,'A',4,1,'COMMAND=',' ')
	  CALL ALPHA(%REF(COMMAND),1,4,LX,NF,NR,2)
	END DO
   5	IF (COMMAND.EQ.'EQNG'.OR.COMMAND.EQ.'EQOG') THEN
C  Obtain the input quantities from the user
	  CALL MESSAGE('Enter the right ascension in hours, minutes,
	1 and seconds:')
	  CALL USRINP(RAPARAM,3,'F',4,1,'RIGHT_ASCENSION=',
	1 '(default = last entry)')
	  CALL HMSDH(RAPARAM(1),RAPARAM(2),RAPARAM(3),RIGHTASC)
	  CALL MESSAGE('Enter the declination in degrees, minutes,
	1 and seconds:')
	  CALL USRINP_DMS(DEGREES,MINUTES,SECONDS,DECLINA,1,
	1 'DECLINATION=','(default = last entry)',17)
C  Compute the output quantities for each case
	  IF (COMMAND.EQ.'EQNG') THEN
	    EPOCH1=1950.0D0
	    CALL USRINP(EPOCH1,1,'F',8,1,'EPOCH=',
	1   'Enter the epoch of the right ascension and declination:
	1  (default = 1950.0)')
	    EPOCH2=1950.0D0
	    IF (EPOCH1.NE.1950.0D0) CALL PRECESSIO(0,EPOCH1,EPOCH2,RIGHTASC,
	1   DECLINA,RIGHTASC,DECLINA)
	    CALL EQNEWGAL(RIGHTASC,DECLINA,LONGITUDEOUT,LATITUDEOUT)
	  ELSE IF (COMMAND.EQ.'EQOG') THEN
	    EPOCH1=1900.0D0
	    CALL USRINP(EPOCH1,1,'F',8,1,'EPOCH=',
	1   'Enter the epoch of the right ascension and declination:
	1  (default = 1900.0)')
	    EPOCH2=1900.0D0
	    IF (EPOCH1.NE.1900.0D0) CALL PRECESSIO(0,EPOCH1,EPOCH2,RIGHTASC,
	1   DECLINA,RIGHTASC,DECLINA)
	    CALL EQOLDGAL(RIGHTASC,DECLINA,LONGITUDEOUT,LATITUDEOUT)
	  END IF
	  CALL DHHMS(LONGITUDEOUT,0.0,DEG,MIN,SEC,DUMMY)
	  WRITE (6,1001) INT(DEG),INT(MIN),SEC
1001	  FORMAT (' Longitude = ',I3,' degrees ',I2,' minutes ',F9.5,
	1 ' seconds')
	  WRITE (7,1001) INT(DEG),INT(MIN),SEC
	  CALL DHHMS(LATITUDEOUT,0.0,DEG,MIN,SEC,CSIGN)
	  WRITE (6,1002) CSIGN,INT(DEG),INT(MIN),SEC
1002	  FORMAT (' Latitude = ',A1,I3,' degrees ',I2,' minutes ',F9.5,
	1 ' seconds')
	  WRITE (7,1002) CSIGN,INT(DEG),INT(MIN),SEC
	ELSE IF (COMMAND.EQ.'NGEQ'.OR.COMMAND.EQ.'OGEQ'.OR.COMMAND.EQ.'NGOG'
	1.OR.COMMAND.EQ.'OGNG'.OR.COMMAND.EQ.'NGSG'.OR.COMMAND.EQ.'OGSG') THEN
C  Obtain the input quantities from the user
	  CALL MESSAGE('Enter the galactic longitude in degrees, minutes,
	1 and seconds:')
	  CALL USRINP_DMS(DEGREES,MINUTES,SECONDS,LONGITUDEIN,1,
	1 'GALACTIC_LONGITUDE=','(default = last entry)',17)
	  CALL MESSAGE('Enter the galactic latitude in degrees, minutes,
	1 and seconds:')
	  CALL USRINP_DMS(DEGREES2,MINUTES2,SECONDS2,LATITUDEIN,1,
	1 'GALACTIC_LATITUDE=','(default = last entry)',17)
C  Compute the output quantities for each case
	  IF (COMMAND.EQ.'NGEQ') THEN
	    CALL NEWGALEQ(LONGITUDEIN,LATITUDEIN,RIGHTASC,DECLINA)
	    EPOCH1=1950.0D0
	    CALL MESSAGE('Enter the desired epoch of the right ascension
	1 and declination:')
	    CALL USRINP(EPOCH1,1,'F',8,1,'EPOCH=','(default = 1950.0)')
	    EPOCH2=1950.0D0
	    IF (EPOCH1.NE.1950.0D0) CALL PRECESSIO(0,EPOCH1,EPOCH2,RIGHTASC,
	1   DECLINA,RIGHTASC,DECLINA)
	    CALL DHHMS(RIGHTASC,0.0,DEG,MIN,SEC,DUMMY)
	    WRITE (6,2001) INT(DEG),INT(MIN),SEC
2001	    FORMAT (' Right Ascension = ',I3,' hours ',I2,' minutes ',F9.6,
	1   ' seconds')
	    WRITE (7,2001) INT(DEG),INT(MIN),SEC
	    CALL DHHMS(DECLINA,0.0,DEG,MIN,SEC,CSIGN)
	    WRITE (6,2002) CSIGN,INT(DEG),INT(MIN),SEC
2002	    FORMAT (' Declination = ',A1,I3,' degrees ',I2,' minutes ',F9.5,
	1   ' seconds')
	    WRITE (7,2002) CSIGN,INT(DEG),INT(MIN),SEC
	  ELSE IF (COMMAND.EQ.'OGEQ') THEN
	    CALL OLDGALEQ(LONGITUDEIN,LATITUDEIN,RIGHTASC,DECLINA)
	    EPOCH1=1900.0D0
	    CALL MESSAGE('Enter the desired epoch of the right ascension
	1 and declination:')
	    CALL USRINP(EPOCH1,1,'F',8,1,'EPOCH=','(default = 1900.0)')
	    EPOCH2=1900.0D0
	    IF (EPOCH1.NE.1900.0D0) CALL PRECESSIO(0,EPOCH1,EPOCH2,RIGHTASC,
	1   DECLINA,RIGHTASC,DECLINA)
	    CALL DHHMS(RIGHTASC,0.0,DEG,MIN,SEC,DUMMY)
	    WRITE (6,2001) INT(DEG),INT(MIN),SEC
	    WRITE (7,2001) INT(DEG),INT(MIN),SEC
	    CALL DHHMS(DECLINA,0.0,DEG,MIN,SEC,CSIGN)
	    WRITE (6,2002) CSIGN,INT(DEG),INT(MIN),SEC
	    WRITE (7,2002) CSIGN,INT(DEG),INT(MIN),SEC
	  ELSE IF (COMMAND.EQ.'NGOG') THEN
	    CALL NEWOLDGAL(LONGITUDEIN,LATITUDEIN,LONGITUDEOUT,LATITUDEOUT)
	    CALL DHHMS(LONGITUDEOUT,0.0,DEG,MIN,SEC,DUMMY)
	    WRITE (6,1001) INT(DEG),INT(MIN),SEC
	    WRITE (7,1001) INT(DEG),INT(MIN),SEC
	    CALL DHHMS(LATITUDEOUT,0.0,DEG,MIN,SEC,CSIGN)
	    WRITE (6,1002) CSIGN,INT(DEG),INT(MIN),SEC
	    WRITE (7,1002) CSIGN,INT(DEG),INT(MIN),SEC
	  ELSE IF (COMMAND.EQ.'OGNG') THEN
	    CALL OLDNEWGAL(LONGITUDEIN,LATITUDEIN,LONGITUDEOUT,LATITUDEOUT)
	    CALL DHHMS(LONGITUDEOUT,0.0,DEG,MIN,SEC,DUMMY)
	    WRITE (6,1001) INT(DEG),INT(MIN),SEC
	    WRITE (7,1001) INT(DEG),INT(MIN),SEC
	    CALL DHHMS(LATITUDEOUT,0.0,DEG,MIN,SEC,CSIGN)
	    WRITE (6,1002) CSIGN,INT(DEG),INT(MIN),SEC
	    WRITE (7,1002) CSIGN,INT(DEG),INT(MIN),SEC
	  ELSE IF (COMMAND.EQ.'NGSG') THEN
	    CALL NEWGALSUPERGAL(LONGITUDEIN,LATITUDEIN,LONGITUDEOUT,
	1   LATITUDEOUT)
	    CALL DHHMS(LONGITUDEOUT,0.0,DEG,MIN,SEC,DUMMY)
	    WRITE (6,1001) INT(DEG),INT(MIN),SEC
	    WRITE (7,1001) INT(DEG),INT(MIN),SEC
	    CALL DHHMS(LATITUDEOUT,0.0,DEG,MIN,SEC,CSIGN)
	    WRITE (6,1002) CSIGN,INT(DEG),INT(MIN),SEC
	    WRITE (7,1002) CSIGN,INT(DEG),INT(MIN),SEC
	  ELSE IF (COMMAND.EQ.'OGSG') THEN
	    CALL OLDNEWGAL(LONGITUDEIN,LATITUDEIN,LONGITUDEOUT,LATITUDEOUT)
	    CALL NEWGALSUPERGAL(LONGITUDEOUT,LATITUDEOUT,LONGITUDEOUT,
	1   LATITUDEOUT)
	    CALL DHHMS(LONGITUDEOUT,0.0,DEG,MIN,SEC,DUMMY)
	    WRITE (6,1001) INT(DEG),INT(MIN),SEC
	    WRITE (7,1001) INT(DEG),INT(MIN),SEC
	    CALL DHHMS(LATITUDEOUT,0.0,DEG,MIN,SEC,CSIGN)
	    WRITE (6,1002) CSIGN,INT(DEG),INT(MIN),SEC
	    WRITE (7,1002) CSIGN,INT(DEG),INT(MIN),SEC
	  END IF
	END IF
	MORE=.FALSE.
	CALL USRINP(MORE,1,'L',1,1,'MORE=','More conversion with this command?  
	1(default = N)')
	IF (MORE) GO TO 5
	RETURN
	END
