	SUBROUTINE FAKGAL1(LU_OUT,ARRAY1,ARRAY2,LENGTHX,LENGTHY,
	1COMMAND,NCOLS,NROWS,COLUMN,COLUMNS_ABS,ROW,ROW_ABS,
	2INDEXMINUSRADIUS,INDEXMINUSRADIUS_ABS,PARAM_PRF,PARAM_PRF_ABS,
	3NPTS,NPTS_ABS,MNCOLUMN,MNROW,MXCOLUMN,MXROW,INCLINA,
	4INCLINA_ABS,ECCENTR,ECCENTR_ABS,PARAMETRS,PARAMETRS_ABS,
	5SKY,SKY_ABS,GRADPARAM,SCALE,CONVOLVE,RADIUSOUT,ARRAYOUT,
	6ARRAYOUT_ABS,CHOICE,GRADIENT,OPTICALDEPTH)
C
C       This subroutine helps FAKGAL and FAKSTAR by allowing operation
C  of the subroutine DYNAMIC.
C			Donald H. Gudehus, November, 1982
C			Versin 1U, Donald H. Gudehus, February 17, 2008
C			Converted to Unix and FITS
C
C	ARRAY1	(R)	The array containing the pixel intensity values
C	ARRAY2	(R)	The array containing an accounting of how
C			many times a pixel was written to for COMMAND
C			= P or PA.
C	LENGTHX	(C)	The dimension of the array in the x direction
C	LENGTHY	(C)	The dimension of the array in the y direction
C
	INCLUDE 'miipspar.for'
C
	CHARACTER*1 GRADIENT,CHOICE
	CHARACTER*2 COMMAND
C
	INTEGER LU_OUT,LENGTHX,LENGTHY,NCOLS,NROWS,NPTS,NPTS_ABS,MNCOLUMN,
	1MNROW,MXCOLUMN,MXROW
C
	LOGICAL CONVOLVE
C
	REAL*4 ARRAY1(LENGTHX,LENGTHY),ARRAY2(LENGTHX,LENGTHY),COLUMN,
	1COLUMN_ABS,ROW,ROW_ABS,INDEXMINUSRADIUS,INDEXMINUSRADIUS_ABS,
	2PARAM_PRF(5,MAXDIAG),PARAM_PRF_ABS(5,MAXDIAG),INCLINA,INCLINA_ABS,
	3ECCENTR,ECCENTR_ABS,PARAMETRS(4),PARAMETRS_ABS(4),SKY_ABS,
	4GRADPARAM(2),SCALE,RADIUSOUT(MAXDIAG),ARRAYOUT(MAXDIAG),
	5OPTICALDEPTH
C
C
	CHARACTER*1 ITERATION_SCHEME,CHOICE_ABS
	CHARACTER*6 CHOICENLF
C
	INTEGER DIMENSN_DATA
	PARAMETER (DIMENSN_DATA=1,MAXNUMPARAM=11)
	INTEGER STARTRADIUS,IXNLF(2),KBEST,MINIXARRAY,MINIYARRAY,
	1MAXIXARRAY,MAXIYARRAY,IXARRAY,IYARRAY,NTIMES,ADDRESS3,NUMPIXELS,
	2II,JJ
C
	LOGICAL TOONOISY,CONST(MAXNUMPARAM)
C
	REAL*4 YMIN,DISTANCE,RADIUSLIMIT,ADU,FORESHORT,
	1CS,SN,ANGLIMIT,DELTAE,XELLIPSE,YELLIPSE,XARRAY,YARRAY,XCEN,YCEN,
	2XCENPRIME,YCENPRIME,ACEN,P,A,B,E,X,Y,ADUWRITE,ADUREAD,SEMIMAJAX,
	3DATA(MAXSIZE),ARRAYOUT_ABS(MAXDIAG),XY,YP,SKY,RADIUS,
	4AVERAGE,SUM
C
	REAL*8 XX(10,1),YY(10,1),W(10),COEFF(MAXNUMPARAM),MEBEST,
	1COVAR(MAXNUMPARAM,MAXNUMPARAM),ME(DIMENSN_DATA),
	2MEME(DIMENSN_DATA),REDCHISQ(DIMENSN_DATA),AVREDCHISQ,
	3RESIDUALS(10,DIMENSN_DATA)
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
C  Zero the arrays
	DO J=1,LENGTHY
	  DO I=1,LENGTHX
	    ARRAY1(I,J)=0.0
	    ARRAY2(I,J)=0.0
	  END DO
	END DO
C
	IF (COMMAND(1:1).EQ.'P') THEN !  Input is from data files prepared by
				      !  options PR or EA
C  Find the starting radius;  this will be greater than zero if the
C  center of the image lies outside the area of the map.  By beginning
C  the loop below at the starting radius, the calculation time is
C  lessened.
	  STARTRADIUS=JINT(COLUMN)-NCOLS !  Center of galaxy outside of
					 !  map on right side
	  STARTRADIUS=JMAX0(STARTRADIUS,1-JINT(COLUMN)) !  left side
	  STARTRADIUS=JMAX0(STARTRADIUS,JINT(ROW)-NROWS)!  top
	  STARTRADIUS=JMAX0(STARTRADIUS,1-JINT(ROW)) !  bottom
	  IF (STARTRADIUS.LT.0) STARTRADIUS=0 !  within map
	  STARTRADIUS=JMAX0(STARTRADIUS,JINT(1.0-INDEXMINUSRADIUS))
C  Alter RADIUSLIMIT so that it does not exceed five times the distance
C  from the center of the galaxy to the most distant corner of the map.
C  This allows for an object with an eccentricity as great as .98.
	  DISTANCE=SQRT((COLUMN-1.0)**2+(FLOATJ(NROWS)-ROW)**2)
			!  Distance to the upper left corner
	  DISTANCE=AMAX1(DISTANCE,SQRT((COLUMN-FLOATJ(NCOLS))**2+
	1 (FLOATJ(NROWS)-ROW)**2))
			!  upper right
	  DISTANCE=AMAX1(DISTANCE,SQRT((COLUMN-FLOATJ(NCOLS))**2+
	1 (ROW-1.0)**2))
			!  lower right
	  DISTANCE=AMAX1(DISTANCE,SQRT((COLUMN-1.0)**2+(ROW-1.0)**2))
			!  lower left
	  RADIUSLIMIT=AMIN1(5.0*DISTANCE,FLOAT(NPTS)-INDEXMINUSRADIUS)
C
C  Perform a least squares fit to a gaussian for the central pixels if the
C  data is not too noisy and the data has a peak in the center.
	  YMIN=PARAM_PRF(5,1)
	  DO I=2,NPTS
	    IF (PARAM_PRF(5,I).LT.YMIN) YMIN=PARAM_PRF(5,I)
	  END DO
	  TOONOISY=.FALSE.
	  IF (PARAM_PRF(5,2).GE.PARAM_PRF(5,1)) TOONOISY=.TRUE.
	  IF (.NOT.TOONOISY.AND.INDEXMINUSRADIUS.EQ.1) THEN
	    DO I=1,10
	      XX(I,1)=I-INDEXMINUSRADIUS
	      YY(I,1)=PARAM_PRF(5,I)-YMIN
	      W(I)=SQRT(1.0+I-1)
	    END DO
	    CHOICENLF='G'
	    CONST(1)=.FALSE.
	    CONST(2)=.FALSE.
	    CONST(3)=.TRUE.
	    CONST(4)=.TRUE.
C  Select only the pixels near the very center
	    I=1
	    DO WHILE(PARAM_PRF(5,I)-YMIN.GT.0.607*PARAM_PRF(5,1)-YMIN)
	      I=I+1
	    END DO
C  Load the estimates for NONLINFIT
	    COEFF(1)=PARAM_PRF(5,1)-YMIN  ! Central surface brightness
	    COEFF(2)=I-1 !  Sigma
	    COEFF(3)=0.0 !  X location
	    COEFF(4)=0.0 !  Constant term
	    ITERATION_SCHEME='C'
	    MEBEST=1.0E37
C  Try various solutions and pick the best
	    DO K=3,6
	      IXNLF(1)=1
	      IXNLF(2)=K
	      CALL NONLINFIT(XX,10,1,YY,DIMENSN_DATA,W,
	2     IXNLF,10,CHOICENLF,CONST,COEFF,MAXNUMPARAM,
	3     4,ITERATION_SCHEME,0.0001,.FALSE.,.FALSE.,
	4     COVAR,ME,MEME,REDCHISQ,AVREDCHISQ,XP,YP,1,RESIDUALS)
	      IF (ME(1).LT.MEBEST) THEN
	        MEBEST=ME(1)
	        KBEST=K
	      END IF
	      WRITE (7,1000) COEFF(1),COEFF(2),COEFF(3),COEFF(4)
1000	      FORMAT(' ',' Coefficients of gaussian fit to center'/
	1     4G16.8)
	    END DO
	    IXNLF(2)=KBEST
	    CALL NONLINFIT(XX,10,1,YY,DIMENSN_DATA,W,
	2   IXNLF,10,CHOICENLF,CONST,COEFF,MAXNUMPARAM,
	3   4,ITERATION_SCHEME,0.0001,.FALSE.,.FALSE.,
	4   COVAR,ME,MEME,REDCHISQ,AVREDCHISQ,XP,YP,1,RESIDUALS)
C  Use the coefficients from the fit to evaluate the interpolated pixel value
C  in the loop below provided that the data was not too noisy.
	  END IF
C  Load the region beyond the end of the data with values safe for 
C  interpolation 
	  DO K=NPTS+1,NPTS+2
	    DO I=1,5
	      PARAM_PRF(I,K)=PARAM_PRF(I,NPTS)
	    END DO
	  END DO
	  MINIXARRAY=LENGTHX
	  MINIYARRAY=LENGTHY
	  MAXIXARRAY=0
	  MAXIYARRAY=0
	  DO 20 K=STARTRADIUS+JINT(INDEXMINUSRADIUS),
	1 JINT(RADIUSLIMIT+INDEXMINUSRADIUS)
	    A=K-INDEXMINUSRADIUS  ! A is the semimajor axis
	    COLUMN=PARAM_PRF(1,K)
	    ROW=PARAM_PRF(2,K)
	    INCLINA=PARAM_PRF(3,K)
	    ECCENTR=PARAM_PRF(4,K)
	    ADU=PARAM_PRF(5,K)
	    FORESHORT=MAX(1E-37,SQRT(1.0-ECCENTR**2))
	    B=A*FORESHORT
	    CS=COSD(INCLINA)
	    SN=SIND(INCLINA)
C  Calculate the angular increment
	    IF (A.GT.0.) THEN
	      DELTAE=0.5/A
	    ELSE
	      DELTAE=6.28
	    END IF
C  Get X and Y for the array by means of a radius vector originating
C  from the center of the ellipse;  increment along the circumference
C  of a circle with radius equal to A in equal amounts, ie., 0.5 pixel.
	    E=0.0
	    ANGLIMIT=6.28318-DELTAE*0.5
	    DO 10 WHILE (E.LT.ANGLIMIT)
	      XELLIPSE=A*COS(E)*CS-B*SIN(E)*SN
	      YELLIPSE=A*COS(E)*SN+B*SIN(E)*CS
	      IF (K.GE.1.AND.K.LE.MIN(50,INT(RADIUSLIMIT)+
	1     INT(INDEXMINUSRADIUS))) THEN
C  For the central region of the galaxy we should write to the center
C  of each pixel with an interpolated value
	        XCEN=INT(XELLIPSE+COLUMN)+0.5-COLUMN
	        YCEN=INT(YELLIPSE+ROW)+0.5-ROW
C  Increment by 1 because array index starts at 1
	        XARRAY=COLUMN-FLOATJ(MNCOLUMN)+1.0+XCEN
	        YARRAY=ROW-FLOATJ(MNROW)+1.0+YCEN
	        IXARRAY=JINT(XARRAY)
	        IYARRAY=JINT(YARRAY)
	        IF (IXARRAY.LT.1.OR.IXARRAY.GT.LENGTHX) GO TO 9
	        IF (IYARRAY.LT.1.OR.IYARRAY.GT.LENGTHY) GO TO 9
C  Transform to a rotated system
	        XCENPRIME=XCEN*CS+YCEN*SN
	        YCENPRIME=YCEN*CS-XCEN*SN
	        ACEN=SQRT(XCENPRIME**2+(YCENPRIME/FORESHORT)**2)
C  Interpolate to get the central value of each pixel
	        P=ACEN-INT(ACEN)
	        IF (ACEN+INDEXMINUSRADIUS.LE.KBEST.AND.(.NOT.TOONOISY))
	1       THEN
	          IF (P.EQ.0.0) THEN
	            ADUWRITE=PARAM_PRF(5,INT(ACEN)+INT(INDEXMINUSRADIUS))
	          ELSE IF (P.EQ.1.0) THEN
	            ADUWRITE=PARAM_PRF(5,INT(ACEN)+1+INT(
	1           INDEXMINUSRADIUS))
	          ELSE
	            ADUWRITE=GAUSS(COEFF,ACEN)+YMIN
	          END IF
	        ELSE IF ((ACEN+INDEXMINUSRADIUS.GT.KBEST.AND.
	1       (.NOT.TOONOISY).AND.ACEN.LE.40).OR.
	2       (ACEN.GE.1.0.AND.ACEN.LE.40.0.AND.TOONOISY)) THEN
	          IF (P.EQ.0.0) THEN
	            ADUWRITE=PARAM_PRF(5,INT(ACEN)+INT(INDEXMINUSRADIUS
	1           ))
	          ELSE IF (P.EQ.1.0) THEN
	            ADUWRITE=PARAM_PRF(5,INT(ACEN)+1+INT(
	1           INDEXMINUSRADIUS))
	          ELSE !  Lagrangian 4-point interpolation
	            ADUWRITE=-P*(P-1.0)*(P-2.0)/6.0*PARAM_PRF(5,INT(ACEN)-
	1           1+INT(INDEXMINUSRADIUS))+
	2           (P**2-1.0)*(P-2.0)/2.0*PARAM_PRF(5,INT(ACEN)+
	3           INT(INDEXMINUSRADIUS))-
	4           P*(P+1.0)*(P-2.0)/2.0*PARAM_PRF(5,INT(ACEN)+1+
	5           INT(INDEXMINUSRADIUS))+
	6           P*(P**2-1.0)/6.0*PARAM_PRF(5,INT(ACEN)+2+
	7           INT(INDEXMINUSRADIUS))
	          END IF
C  If ACEN is less than 1.0 and Lagrangian 4-point interpolation is used,
C  we will read before the data array
	        ELSE !  Linear interpolation
	          ADUWRITE=P*(PARAM_PRF(5,INT(ACEN)+
	1         1+INT(INDEXMINUSRADIUS))-
	2         PARAM_PRF(5,INT(ACEN)+INT(INDEXMINUSRADIUS)))+
	3         PARAM_PRF(5,INT(ACEN)+INT(INDEXMINUSRADIUS))
	        END IF
	      ELSE !  Does not interpolate for large radii
	        XARRAY=COLUMN-FLOATJ(MNCOLUMN)+1.0+XELLIPSE
	        YARRAY=ROW-FLOATJ(MNROW)+1.0+YELLIPSE
	        IXARRAY=JINT(XARRAY)
	        IYARRAY=JINT(YARRAY)
	        IF (IXARRAY.LT.1.OR.IXARRAY.GT.LENGTHX) GO TO 9
	        IF (IYARRAY.LT.1.OR.IYARRAY.GT.LENGTHY) GO TO 9
	        ADUWRITE=ADU
	      END IF
	      IF (ARRAY2(IXARRAY,IYARRAY).EQ.0) THEN
	        ARRAY1(IXARRAY,IYARRAY)=ADUWRITE
	      ELSE !  Average the multiple values written to this
		   !  pixel
	        ARRAY1(IXARRAY,IYARRAY)=(ARRAY2(
	1       IXARRAY,IYARRAY)*ARRAY1(IXARRAY,
	2       IYARRAY)+ADUWRITE)/(ARRAY2(IXARRAY,IYARRAY)+1)
	      END IF
	      ARRAY2(IXARRAY,IYARRAY)=ARRAY2(IXARRAY,
	1     IYARRAY)+1 !  Keep an accounting of how many times
			 !  each pixel gets written to.
	      MINIXARRAY=MIN(MINIXARRAY,IXARRAY)
	      MINIYARRAY=MIN(MINIYARRAY,IYARRAY)
	      MAXIXARRAY=MAX(MAXIXARRAY,IXARRAY)
	      MAXIYARRAY=MAX(MAXIYARRAY,IYARRAY)
C	      IF (K.LT.5) WRITE(7,*) IXARRAY,IYARRAY,ACEN,ADUWRITE
   9	      E=E+DELTAE
  10	    CONTINUE
  20	  CONTINUE
C  Check that there are no zero values in the array produced by
C  skipping over pixels or by nonconcentric successive annuli when using
C  commands B and P.
	  DO 38 J=MINIYARRAY,MAXIYARRAY
	    DO 38 I=MINIXARRAY,MAXIXARRAY
	      IF (ARRAY2(I,J).NE.0.0) GO TO 38  ! Value OK
C  Test to see if you are within the region of galaxy data;  use the
C  parameters from the last contour.
	      X=FLOATJ(MNCOLUMN+I)-COLUMN-0.5
	      Y=FLOATJ(MNROW+J)-ROW-0.5
	      SEMIMAJAX=SQRT((X*CS+Y*SN)**2+(-X*SN+Y*CS)**2/FORESHORT
	1     **2)
	      IF (SEMIMAJAX.GT.A.OR.SEMIMAJAX.LT.STARTRADIUS) GO TO 38
					!  Outside the galaxy data
C  Replace the pixel value skipped above by the average of the pixel
C  values in a circle centered on the pixel.  The radius will be
C  increased by 1 pixel unit untill an average is obtained.
	      RADIUS=1.0
	      AVERAGE=0.0
	      DO WHILE (AVERAGE.EQ.0.0.AND.RADIUS.LT.5.0)
	        DELTAE=1.0/RADIUS
	        ANGLIMIT=6.28318-DELTAE*0.5
	        E=0.0
	        SUM=0.0
	        NUMPIXELS=0
	        DO WHILE (E.LT.ANGLIMIT)
	          II=I+JINT(RADIUS*COS(E))
	          JJ=J+JINT(RADIUS*SIN(E))
	          IF (II.LT.MINIXARRAY.OR.II.GT.MAXIXARRAY.OR.JJ.LT.
	1         MINIYARRAY.OR.JJ.GT.MAXIYARRAY) GO TO 30
	          IF (ARRAY2(II,JJ).EQ.0.0) GO TO 30
	          SUM=SUM+ARRAY1(II,JJ)
	          NUMPIXELS=NUMPIXELS+1
  30	          E=E+DELTAE
	        END DO
	        IF (SUM.GT.0.0) THEN
	          AVERAGE=SUM/FLOATJ(NUMPIXELS)
	        END IF
	        RADIUS=RADIUS+1.0
	      END DO
C  Write to the array
	      ARRAY1(I,J)=AVERAGE
  38	  CONTINUE
C  Check the value of the central pixel with a tapered sinc interpolation
C  and adjust if necessary.
	  COLUMN=PARAM_PRF(1,1)
	  ROW=PARAM_PRF(2,1)
	  XARRAY=COLUMN-FLOATJ(MNCOLUMN)+1.0
	  YARRAY=ROW-FLOATJ(MNROW)+1.0
	  IXARRAY=JINT(XARRAY)
	  IYARRAY=JINT(YARRAY)
	  ADUREAD=PARAM_PRF(5,1)
	  ADU=0.0
	  NTIMES=0
	  DO WHILE (ABS(ADUREAD-ADU).GT.0.001*ADUREAD.AND.
	1 NTIMES.LT.1000)
	    ADU=SINTERP2D(ARRAY1,LENGTHX,LENGTHY,XARRAY,YARRAY,5,1.33)
	    IF (ADU.LT.ADUREAD) THEN
	      ARRAY1(IXARRAY,IYARRAY)=1.0005*ARRAY1(IXARRAY,IYARRAY)
	    ELSE IF (ADU.GT.ADUREAD) THEN
	      ARRAY1(IXARRAY,IYARRAY)=0.9995*ARRAY1(IXARRAY,IYARRAY)
	    END IF
	    NTIMES=NTIMES+1
	  END DO
C  Now subtract the sky level for the region interior to the ellipse.
C  This couldn't be done in loop 10 because if the sky was defaulted to
C  the minimum, a zero would result for an outer contour which would
C  then be altered by the loop that checks for zeros.
	  DO J=1,LENGTHY
	    DO I=1,LENGTHX
	      IF (ARRAY1(I,J).NE.0.0) ARRAY1(I,J)=ARRAY1(I,J)-SKY
	    END DO
	  END DO
C
	ELSE IF (COMMAND(1:1).EQ.'M'.OR.COMMAND.EQ.'F') THEN !  Manual input 
				!  of data or from file
	  FORESHORT=SQRT(1.0-ECCENTR**2)
	  CS=COSD(INCLINA)
	  SN=SIND(INCLINA)
	  DO J=1,LENGTHY
	    DO I=1,LENGTHX
C  X and Y are the coordinates of the center of the pixel (0.5,0.5)
C  to be written to, relative to the center of the galaxy.
	      X=FLOATJ(MNCOLUMN+I)-COLUMN-0.5
	      Y=FLOATJ(MNROW+J)-ROW-0.5
	      SEMIMAJAX=SQRT((X*CS+Y*SN)**2+(-X*SN+Y*CS)**2/FORESHORT
	1     **2)
C  The surface brightness information is in the array ARRAYOUT
C  when convolution is asked for and then only at integral pixel locations.
C  More accuracy is obtained by calling FAKGALFUN when convolution is not
C  required.
	      IF (CONVOLVE) THEN
	        CALL POLINTERP1D(RADIUSOUT,ARRAYOUT,NPTS,SEMIMAJAX,ADU,2,
	1       1,COEFF)
	      ELSE
	        CALL FAKGALFUN(CHOICE,PARAMETRS,SEMIMAJAX,
	1       GRADIENT,GRADPARAM,ADU)
	      END IF
	      ARRAY1(I,J)=ADU
	    END DO
	  END DO
C  Rewrite the pixels corresponding to the center of the galaxy because
C  their values should be an average of the surface brightness over their
C  own areas.
	  DO IY=-2,2
	    DO IX=-2,2 !  25 Central pixels
	      ADU=0.0
	      DO J=1,10
	        DO I=1,10
	          X=IX+AINT(COLUMN)-COLUMN+(FLOATJ(I)-0.5)/10.0
	          Y=IY+AINT(ROW)-ROW+(FLOATJ(J)-0.5)/10.0
	          SEMIMAJAX=SQRT((X*CS+Y*SN)**2+(-X*SN+Y*CS)**2/FORESHORT
	1         **2)
	          CALL FAKGALFUN(CHOICE,PARAMETRS,SEMIMAJAX,
	1         GRADIENT,GRADPARAM,TERM)
	          ADU=ADU+TERM
  	        END DO
	      END DO
	      IXARRAY=IX+JINT(COLUMN-FLOAT(MNCOLUMN)+1.0)
	      IYARRAY=IY+JINT(ROW-FLOAT(MNROW)+1.0)
	      IF (IXARRAY.GE.1.AND.IXARRAY.LE.LENGTHX.AND.IYARRAY.GE.1
	1     .AND.IYARRAY.LE.LENGTHY) ARRAY1(IXARRAY,IYARRAY)=ADU/100.0
	    END DO
	  END DO
	END IF
C  Now take care of calculating any absorption from another galaxy.  For
C  commands PA and PB, we need a new array, ARRAY3, which serves as did ARRAY2
C  in this subroutine.  ARRAY2 is overwritten with the surface brightness of
C  the absorber galaxy.
	IF (COMMAND.EQ.'PA'.OR.COMMAND.EQ.'PB'.OR.COMMAND.EQ.'MA'.OR.
	1COMMAND.EQ.'MB') THEN
	  CALL DYNAMIC(ADDRESS3,LENGTHX*LENGTHY,'  R4',.TRUE.)
	  CALL FAKGAL3(ARRAY2,%VAL(ADDRESS3),LENGTHX,LENGTHY,COMMAND,
	1 NCOLS,NROWS,COLUMN_ABS,ROW_ABS,INDEXMINUSRADIUS,PARAM_PRF_ABS,
	2 NPTS_ABS,MNCOLUMN,MNROW,PARAMETRS_ABS,SKY_ABS,GRADPARAM,CONVOLVE,
	3 ARRAYOUT_ABS,CHOICE_ABS,GRADIENT,RADIUSOUT)
	  CALL DYNAMIC(ADDRESS3,LENGTHX*LENGTHY,'  R4',.FALSE.)
	END IF
C  Write to the file, incorporating any absorption
	IF (COMMAND.EQ.'P'.OR.COMMAND.EQ.'M'.OR.COMMAND.EQ.'F') THEN
	  DO J=MNROW,MXROW
	    CALL RDFITSROW(LU_OUT,IMNUM,IPNUM,DATA,NCOLS,J)
	    DO I=MNCOLUMN,MXCOLUMN
	      DATA(I)=DATA(I)+SCALE*ARRAY1(I-MNCOLUMN+1,J-MNROW+1)
	    END DO
	    CALL WRFITSROW(LU_OUT,IMNUM,IPNUM,DATA,NCOLS,J)
	  END DO
	ELSE IF (COMMAND.EQ.'PA'.OR.COMMAND.EQ.'MA') THEN !  Only for FAKGAL
C  Construct the galaxy and the absorption
C  Get the value at the center in order to normalize
	  IF (COMMAND.EQ.'PA') THEN
	    ADU=PARAM_PRF_ABS(5,1)-SKY_ABS
	  ELSE IF (COMMAND.EQ.'MA') THEN
	    IF (CONVOLVE) THEN
	      ADU=ARRAYOUT_ABS(1)
	    ELSE
	      CALL FAKGALFUN(CHOICE_ABS,PARAMETRS_ABS,0.0,
	1     GRADIENT,GRADPARAM,ADU)
	    END IF
	  END IF
	  DO J=MNROW,MXROW
	    CALL RDFITSROW(LU_OUT,IMNUM,IPNUM,DATA,NCOLS,J)
	    DO I=MNCOLUMN,MXCOLUMN
	      ARRAY2(I-MNCOLUMN+1,J-MNROW+1)=ARRAY2(I-MNCOLUMN+1,J-MNROW+1)
	1     /ADU
	      DATA(I)=DATA(I)+SCALE*ARRAY1(I-MNCOLUMN+1,J-MNROW+1)*
	1     EXP(-OPTICALDEPTH*ARRAY2(I-MNCOLUMN+1,J-MNROW+1))
	    END DO
	    CALL WRFITSROW(LU_OUT,IMNUM,IPNUM,DATA,NCOLS,J)
	  END DO
	ELSE IF (COMMAND.EQ.'PB'.OR.COMMAND.EQ.'MB') THEN !  Only for FAKGAL
C  Construct only the absorption
C  Get the value at the center in order to normalize
	  IF (COMMAND.EQ.'PB') THEN
	    ADU=PARAM_PRF_ABS(5,1)-SKY_ABS
	  ELSE IF (COMMAND.EQ.'MB') THEN
	    IF (CONVOLVE) THEN
	      ADU=ARRAYOUT_ABS(1)
	    ELSE
	      CALL FAKGALFUN(CHOICE_ABS,PARAMETRS_ABS,0.0,
	1     GRADIENT,GRADPARAM,ADU)
	    END IF
	  END IF
	  DO J=MNROW,MXROW
	    CALL RDFITSROW(LU_OUT,IMNUM,IPNUM,DATA,NCOLS,J)
	    DO I=MNCOLUMN,MXCOLUMN
	      ARRAY2(I-MNCOLUMN+1,J-MNROW+1)=ARRAY2(I-MNCOLUMN+1,J-MNROW+1)
	1     /ADU
	      DATA(I)=DATA(I)+SCALE*ARRAY1(I-MNCOLUMN+1,J-MNROW+1)*
	1     (1.0-EXP(-OPTICALDEPTH*ARRAY2(I-MNCOLUMN+1,J-MNROW+1)))
	    END DO
	    CALL WRFITSROW(LU_OUT,IMNUM,IPNUM,DATA,NCOLS,J)
	  END DO
	END IF
	RETURN
	END
