	SUBROUTINE FAKGAL3(ARRAY2,ARRAY3,LENGTHX,LENGTHY,COMMAND,
	1NCOLS,NROWS,COLUMN_ABS,ROW_ABS,INDEXMINUSRADIUS,PARAM_PRF_ABS,
	2NPTS_ABS,MNCOLUMN,MNROW,PARAMETRS_ABS,SKY_ABS,GRADPARAM,CONVOLVE,
	3ARRAYOUT_ABS,CHOICE_ABS,GRADIENT,RADIUSOUT)
C
C       This subroutine helps FAKGAL1 when a second galaxy produces
C  absorption.
C			Donald H. Gudehus, October, 1986
C			Version 2, Donald H. Gudehus, February 18, 2008
C			Modified code to be compatible with changes in
C			FAKGAL1
C
C	ARRAY2	(R)	The array containing the pixel intensity values
C	ARRAY3	(R)	The array containing an accounting of how
C			many times a pixel was written to for COMMAND
C			= PA.
C	LENGTHX	(C)	The dimension of the array in the x direction
C	LENGTHY	(C)	The dimension of the array in the y direction
C
	INCLUDE 'miipspar.for'
C
	CHARACTER*1 CHOICE_ABS,GRADIENT
	CHARACTER*2 COMMAND
C
	INTEGER LENGTHX,LENGTHY,NCOLS,NROWS,NPTS_ABS,MNCOLUMN,MNROW
C
	LOGICAL CONVOLVE
C
	REAL*4 ARRAY2(LENGTHX,LENGTHY),ARRAY3(LENGTHX,LENGTHY),
	1COLUMN_ABS,ROW_ABS,INDEXMINUSRADIUS,PARAM_PRF_ABS(5,MAXDIAG),
	2PARAMETRS_ABS(4),SKY_ABS,GRADPARAM(2),RADIUSOUT(MAXDIAG),
	3ARRAYOUT_ABS(MAXDIAG)
C
C
	CHARACTER*1 ITERATION_SCHEME
	CHARACTER*6 CHOICENLF
C
	INTEGER DIMENSN_DATA
	PARAMETER (DIMENSN_DATA=1,MAXNUMPARAM=11)
	INTEGER STARTRADIUS,IXNLF(2),KBEST,IXARRAY,IYARRAY,MINIXARRAY,
	1MINIYARRAY,MAXIXARRAY,MAXIYARRAY,NUMPIXELS,II,JJ,NTIMES
C
	LOGICAL CONST(MAXNUMPARAM),TOONOISY
C
	REAL*4 INCLINA_ABS,ECCENTR_ABS,RADIUSLIMIT_ABS,DISTANCE,YMIN,
	1XP,YP,A,ADU,ADUWRITE,ADUREAD,B,E,CS,SN,FORESHORT,DELTAE,XELLIPSE,
	2YELLIPSE,XCEN,YCEN,XCENPRIME,YCENPRIME,ACEN,XARRAY,YARRAY,
	3P,SEMIMAJAX,RADIUS,SUM,AVERAGE
C
	REAL*8 XX(10,1),YY(10,1),W(10),COEFF(MAXNUMPARAM),
	1COVAR(MAXNUMPARAM,MAXNUMPARAM),ME(DIMENSN_DATA),MEME(DIMENSN_DATA),
	2MEBEST,REDCHISQ(DIMENSN_DATA),AVREDCHISQ,RESIDUALS(10,DIMENSN_DATA)
C
C  Zero the arrays
	DO J=1,LENGTHY
	  DO I=1,LENGTHX
	    ARRAY2(I,J)=0.0
	    ARRAY3(I,J)=0.0
	  END DO
	END DO
C
	IF (COMMAND.EQ.'PA'.OR.COMMAND.EQ.'PB') THEN !  Input is from data
						     !  files prepared by
						     !  options PR or EA
C  Find the starting radius;  this will be greater than zero if the
C  center of the image lies outside the area of the map.  By beginning
C  the loop below at the starting radius, the calculation time is
C  lessened.
	  STARTRADIUS=JINT(COLUMN_ABS)-NCOLS !  Center of galaxy outside of
					      !  map on right side
	  STARTRADIUS=JMAX0(STARTRADIUS,1-JINT(COLUMN_ABS)) !  left side
	  STARTRADIUS=JMAX0(STARTRADIUS,JINT(ROW_ABS)-NROWS) !  top
	  STARTRADIUS=JMAX0(STARTRADIUS,1-JINT(ROW_ABS)) !  bottom
	  IF (STARTRADIUS.LT.0) STARTRADIUS=0 !  within map
	  STARTRADIUS=JMAX0(STARTRADIUS,JINT(1.0-INDEXMINUSRADIUS_ABS))
C  Alter RADIUSLIMIT_ABS so that it does not exceed five times the distance
C  from the center of the galaxy to the most distant corner of the map.
C  This allows for an object with an eccentricity as great as .98.
	  DISTANCE=SQRT((COLUMN_ABS-1.0)**2+(FLOATJ(NROWS)-ROW_ABS)**2)
			!  Distance to the upper left corner
	  DISTANCE=AMAX1(DISTANCE,SQRT((COLUMN_ABS-FLOATJ(NCOLS))**2+
	1 (FLOATJ(NROWS)-ROW_ABS)**2))
			!  upper right
	  DISTANCE=AMAX1(DISTANCE,SQRT((COLUMN_ABS-FLOATJ(NCOLS))**2+
	1 (ROW_ABS-1.0)**2))
			!  lower right
	  DISTANCE=AMAX1(DISTANCE,SQRT((COLUMN_ABS-1.0)**2+(ROW_ABS-1.0)**2))
			!  lower left
	  RADIUSLIMIT_ABS=AMIN1(5.0*DISTANCE,FLOAT(NPTS_ABS)-
	1 INDEXMINUSRADIUS_ABS)
C
C  Perform a least squares fit to a gaussian for the central 6 pixels if the
C  data is not too noisy.
	  YMIN=PARAM_PRF_ABS(5,1)
	  DO I=2,NPTS_ABS
	    IF (PARAM_PRF_ABS(5,I).LT.YMIN) YMIN=PARAM_PRF_ABS(5,I)
	  END DO
	  TOONOISY=.FALSE.
C	  DO I=1,6
C	    IF (PARAM_PRF_ABS(5,I).LE.(YMIN+(PARAM_PRF_ABS(5,1)-
C	1   PARAM_PRF_ABS(5,6))/12.0)) TOONOISY=.TRUE.
C	  END DO
	  IF (.NOT.TOONOISY.AND.INDEXMINUSRADIUS_ABS.EQ.1) THEN
	    DO I=1,6
	      XX(I,1)=I-INDEXMINUSRADIUS_ABS
	      YY(I,1)=LOG(PARAM_PRF_ABS(5,I)-YMIN)
	      W(I)=SQRT(1.0+I-1)
	    END DO
	    CONST(1)=.FALSE.
	    CONST(2)=.FALSE.
	    CONST(3)=.FALSE.
	    CONST(4)=.FALSE.
	    CONST(5)=.FALSE.
	    CONST(6)=.FALSE.
	    DO K=3,6
	      DO KK=2,K-1
C	        CALL LINFIT1D(XX,YY,W,K,KK,CONST,COEFF,COVAR,MAXNUMPARAM,
C	1       ME,XP,YP,1)
	      END DO
	    END DO
	    DO I=1,10
	      XX(I,1)=I-INDEXMINUSRADIUS_ABS
	      YY(I,1)=PARAM_PRF_ABS(5,I)-YMIN
	      W(I)=SQRT(1.0+I-1)
	    END DO
	    CHOICENLF='G'
	    CONST(1)=.FALSE.
	    CONST(2)=.FALSE.
	    CONST(3)=.TRUE.
	    CONST(4)=.TRUE.
	    I=1
	    DO WHILE(PARAM_PRF_ABS(5,I)-YMIN.GT.0.607*PARAM_PRF_ABS(5,1)-YMIN)
	      I=I+1
	    END DO
	    COEFF(1)=PARAM_PRF_ABS(5,1)-YMIN !  Central surface brightness
	    COEFF(2)=I-1 !  Sigma
	    COEFF(3)=0.0 !  X location
	    COEFF(4)=0.0 !  Constant term
	    ITERATION_SCHEME='C'
	    MEBEST=1.0E37
	    DO K=3,6
	      IXNLF(1)=1
C	      IXNLF(2)=MAX(5,2*I-1)
	      IXNLF(2)=K
	      CALL NONLINFIT(XX,10,1,YY,DIMENSN_DATA,W,
	2     IXNLF,10,CHOICENLF,CONST,COEFF,MAXNUMPARAM,
	3     4,ITERATION_SCHEME,0.0001,.FALSE.,.FALSE.,
	4     COVAR,ME,MEME,REDCHISQ,AVREDCHISQ,XP,YP,1,RESIDUALS)
	      IF (ME(1).LT.MEBEST) THEN
	        MEBEST=ME(1)
	        KBEST=K
	      END IF
	      WRITE (7,1000) COEFF(1),COEFF(2),COEFF(3),COEFF(4)
1000	      FORMAT(' ',' Coefficients of gaussian fit to center'/
	1     4G16.8)
	    END DO
	    IXNLF(2)=KBEST
	    CALL NONLINFIT(XX,10,1,YY,DIMENSN_DATA,W,
	2   IXNLF,10,CHOICENLF,CONST,COEFF,MAXNUMPARAM,
	3   4,ITERATION_SCHEME,0.0001,.FALSE.,.FALSE.,
	4   COVAR,ME,MEME,REDCHISQ,AVREDCHISQ,XP,YP,1,RESIDUALS)
C  Use the coefficients from the fit to evaluate the interpolated pixel value
C  in the loop below
	  END IF
C  Load the region beyond the end of the data with values safe for 
C  interpolation
	  DO K=NPTS_ABS+1,NPTS_ABS+2
	    DO I=1,5
	      PARAM_PRF_ABS(I,K)=PARAM_PRF_ABS(I,NPTS_ABS)
	    END DO
	  END DO
C  Note:  PARAM_PRF changed to PARAM_PRF_ABS D.H.G., Feb. 18, 2008
C
	  MINIXARRAY=LENGTHX
	  MINIYARRAY=LENGTHY
	  MAXIXARRAY=0
	  MAXIYARRAY=0
	  DO 20 K=STARTRADIUS+JINT(INDEXMINUSRADIUS_ABS),
	1 JINT(RADIUSLIMIT_ABS+INDEXMINUSRADIUS_ABS)
	    A=K-INDEXMINUSRADIUS_ABS !  A is the semimajor axis
	    COLUMN_ABS=PARAM_PRF_ABS(1,K)
	    ROW_ABS=PARAM_PRF_ABS(2,K)
	    INCLINA_ABS=PARAM_PRF_ABS(3,K)
	    ECCENTR_ABS=PARAM_PRF_ABS(4,K)
	    ADU=PARAM_PRF_ABS(5,K)
	    FORESHORT=MAX(1E-37,SQRT(1.0-ECCENTR_ABS**2))
	    B=A*FORESHORT
	    CS=COSD(INCLINA_ABS)
	    SN=SIND(INCLINA_ABS)
C  Calculate the angular increment
	    IF (A.GT.0.) THEN
	      DELTAE=0.5/A
	    ELSE
	      DELTAE=6.28
	    END IF
C  Get X and Y for the array by means of a radius vector originating
C  from the center of the ellipse;  increment along the circumference
C  of a circle with radius equal to A in equal amounts, ie., 0.5 pixel.
	    E=0.0
	    ANGLIMIT=6.28318-DELTAE*0.5
	    DO 10 WHILE (E.LT.ANGLIMIT)
	      XELLIPSE=A*COS(E)*CS-B*SIN(E)*SN
	      YELLIPSE=A*COS(E)*SN+B*SIN(E)*CS
	      IF (K.GE.1.AND.K.LE.MIN(50,INT(RADIUSLIMIT_ABS)+
	1     INT(INDEXMINUSRADIUS_ABS)-2)) THEN
C  For the central region of the galaxy we should write to the center
C  of each pixel with an interpolated value
	        XCEN=INT(XELLIPSE+COLUMN_ABS)+0.5-COLUMN_ABS
	        YCEN=INT(YELLIPSE+ROW_ABS)+0.5-ROW_ABS
C  Increment by 1 because array index starts at 1
	        XARRAY=COLUMN_ABS-FLOATJ(MNCOLUMN)+1.0+XCEN
	        YARRAY=ROW_ABS-FLOATJ(MNROW)+1.0+YCEN
	        IXARRAY=JINT(XARRAY)
	        IYARRAY=JINT(YARRAY)
	        IF (IXARRAY.LT.1.OR.IXARRAY.GT.LENGTHX) GO TO 9
	        IF (IYARRAY.LT.1.OR.IYARRAY.GT.LENGTHY) GO TO 9
C  Transform to a rotated system
	        XCENPRIME=XCEN*CS+YCEN*SN
	        YCENPRIME=YCEN*CS-XCEN*SN
	        ACEN=SQRT(XCENPRIME**2+(YCENPRIME/FORESHORT)**2)
C  Interpolate to get the central value of each pixel
	        P=ACEN-INT(ACEN)
C	        IF (ACEN.LE.5.0.AND.(.NOT.TOONOISY)) THEN
	        IF (ACEN.LE.MIN(1.2*SNGL(COEFF(2)),3.0).AND.(.NOT.TOONOISY))
	1       THEN
	          IF (P.EQ.0.0) THEN
	            ADUWRITE=PARAM_PRF_ABS(5,INT(ACEN)+
	1           INT(INDEXMINUSRADIUS_ABS))
	          ELSE IF (P.EQ.1.0) THEN
c	            IP=INT(ACEN)+1.0+INT(INDEXMINUSRADIUS_ABS)
	            ADUWRITE=PARAM_PRF_ABS(5,INT(ACEN)+1+INT(
	1           INDEXMINUSRADIUS_ABS))
	          ELSE
	            ADUWRITE=EXP(POL(COEFF,4,ACEN))+YMIN
	          END IF
	          WRITE(7,2000) K,ACEN,ADUWRITE
2000	          FORMAT(' ',I4,2X,G11.5,2X,G14.6,' K ACEN ADUWRITE') 
C	        ELSE IF ((ACEN.GT.5.AND.ACEN.LE.40).OR.
	        ELSE IF ((ACEN.GT.MIN(1.2*SNGL(COEFF(2)),3.0).AND.
	1       ACEN.LE.40).OR.(ACEN.LE.40.0.AND.TOONOISY)) THEN
	          IF (P.EQ.0.0) THEN
	            ADUWRITE=PARAM_PRF_ABS(5,INT(ACEN)+INT(INDEXMINUSRADIUS_ABS
	1           ))
	          ELSE IF (P.EQ.1.0) THEN
	            ADUWRITE=PARAM_PRF_ABS(5,INT(ACEN)+1+INT(
	1           INDEXMINUSRADIUS_ABS))
	          ELSE !  Lagrangian 4-point interpolation
	            ADUWRITE=-P*(P-1.0)*(P-2.0)/6.0*PARAM_PRF_ABS(5,INT(ACEN)-
	1           1+INT(INDEXMINUSRADIUS_ABS))+
	2           (P**2-1.0)*(P-2.0)/2.0*PARAM_PRF_ABS(5,INT(ACEN)+
	3           INT(INDEXMINUSRADIUS_ABS))-
	4           P*(P+1.0)*(P-2.0)/2.0*PARAM_PRF_ABS(5,INT(ACEN)+1+
	5           INT(INDEXMINUSRADIUS_ABS))+
	6           P*(P**2-1.0)/6.0*PARAM_PRF_ABS(5,INT(ACEN)+2+
	7           INT(INDEXMINUSRADIUS_ABS))
	          END IF
	        ELSE  ! Linear interpolation
	          ADUWRITE=P*(PARAM_PRF_ABS(5,INT(ACEN)+
	1         1+INT(INDEXMINUSRADIUS_ABS))-
	2         PARAM_PRF_ABS(5,INT(ACEN)+INT(INDEXMINUSRADIUS_ABS)))+
	3         PARAM_PRF_ABS(5,INT(ACEN)+INT(INDEXMINUSRADIUS_ABS))
	        END IF
	      ELSE ! Do not interpolate for large radii
	        XARRAY=COLUMN_ABS-FLOATJ(MNCOLUMN)+1.0+XELLIPSE
	        YARRAY=ROW_ABS-FLOATJ(MNROW)+1.0+YELLIPSE
	        IXARRAY=JINT(XARRAY)
	        IYARRAY=JINT(YARRAY)
	        IF (IXARRAY.LT.1.OR.IXARRAY.GT.LENGTHX) GO TO 9
	        IF (IYARRAY.LT.1.OR.IYARRAY.GT.LENGTHY) GO TO 9
	        ADUWRITE=ADU
	      END IF
	      IF (ARRAY3(IXARRAY,IYARRAY).EQ.0.0) THEN
	        ARRAY2(IXARRAY,IYARRAY)=ADUWRITE
	      ELSE !  Average the multiple values written to this
		   !  pixel
	        ARRAY2(IXARRAY,IYARRAY)=(ARRAY3(
	1       IXARRAY,IYARRAY)*ARRAY2(IXARRAY,
	2       IYARRAY)+ADUWRITE)/(ARRAY3(IXARRAY,IYARRAY)+1)
	      END IF
	      ARRAY3(IXARRAY,IYARRAY)=ARRAY3(IXARRAY,
	1     IYARRAY)+1  ! Keep an accounting of how many times
			  ! each pixel gets written to.
	      MINIXARRAY=MIN(MINIXARRAY,IXARRAY)
	      MINIYARRAY=MIN(MINIYARRAY,IYARRAY)
	      MAXIXARRAY=MAX(MAXIXARRAY,IXARRAY)
	      MAXIYARRAY=MAX(MAXIYARRAY,IYARRAY)
   9	      E=E+DELTAE
  10	    CONTINUE
  20	  CONTINUE
C  Check that there are no zero values in the array produced by
C  skipping over pixels or by nonconcentric successive annuli when using
C  commands B and P.
	  DO 38 J=MINIYARRAY,MAXIYARRAY
	    DO 38 I=MINIYARRAY,MAXIYARRAY
	      IF (ARRAY3(I,J).NE.0.0) GO TO 38  ! Value OK
C  Test to see if you are within the region of galaxy data;  use the
C  parameters from the last contour.
	      X=FLOATJ(MNCOLUMN+I)-COLUMN_ABS-0.5
	      Y=FLOATJ(MNROW+J)-ROW_ABS-0.5
	      SEMIMAJAX=SQRT((X*CS+Y*SN)**2+(-X*SN+Y*CS)**2/FORESHORT
	1     **2)
	      IF (SEMIMAJAX.GT.A.OR.SEMIMAJAX.LT.STARTRADIUS) GO TO 38
					!  Outside the galaxy data
C  Replace the pixel value skipped above by the average of the pixel
C  values in a circle centered on the pixel.  The radius will be
C  increased by 1 pixel unit untill an average is obtained.
	      RADIUS=1.0
	      AVERAGE=0.0
	      DO WHILE (AVERAGE.EQ.0.0.AND.RADIUS.LT.5.0)
	        DELTAE=1.0/RADIUS
	        ANGLIMIT=6.28318-DELTAE*0.5
	        E=0.0
	        SUM=0.0
	        NUMPIXELS=0
	        DO WHILE (E.LT.ANGLIMIT)
	          II=I+JINT(RADIUS*COS(E))
	          JJ=J+JINT(RADIUS*SIN(E))
	          IF (II.LT.MINIXARRAY.OR.II.GT.MAXIXARRAY.OR.JJ.LT.
	1         MINIYARRAY.OR.JJ.GT.MAXIYARRAY) GO TO 30
	          IF (ARRAY3(II,JJ).EQ.0.0) GO TO 30
	          SUM=SUM+ARRAY2(II,JJ)
	          NUMPIXELS=NUMPIXELS+1
  30	          E=E+DELTAE
	        END DO
	        IF (SUM.GT.0.0) THEN
	          AVERAGE=SUM/FLOATJ(NUMPIXELS)
	        END IF
	        RADIUS=RADIUS+1.0
	      END DO
C  Write to the array
	      ARRAY2(I,J)=AVERAGE
  38	  CONTINUE
C  Check the value of the central pixel with a tapered sinc interpolation
C  and adjust if necessary.
	  COLUMN_ABS=PARAM_PRF_ABS(1,1)
	  ROW_ABS=PARAM_PRF_ABS(2,1)
	  XARRAY=COLUMN_ABS-FLOATJ(MNCOLUMN)+1.0
	  YARRAY=ROW_ABS-FLOATJ(MNROW)+1.0
	  IXARRAY=JINT(XARRAY)
	  IYARRAY=JINT(YARRAY)
	  ADUREAD=PARAM_PRF_ABS(5,1)
	  ADU=0.0
	  NTIMES=0
	  DO WHILE (ABS(ADUREAD-ADU).GT.0.001*ADUREAD.AND.
	1 NTIMES.LT.1000)
	    ADU=SINTERP2D(ARRAY2,LENGTHX,LENGTHY,XARRAY,YARRAY,5,1.33)
	    IF (ADU.LT.ADUREAD) THEN
	      ARRAY2(IXARRAY,IYARRAY)=1.0005*ARRAY2(IXARRAY,IYARRAY)
	    ELSE IF (ADU.GT.ADUREAD) THEN
	      ARRAY2(IXARRAY,IYARRAY)=0.9995*ARRAY2(IXARRAY,IYARRAY)
	    END IF
	    NTIMES=NTIMES+1
	  END DO
C  Now subtract the sky level for the region interior to the ellipse.
C  This couldn't be done in loop 10 because if the sky was defaulted to
C  the minimum, a zero would result for an outer contour which would
C  then be altered by the loop that checks for zeros.
	  DO J=1,LENGTHY
	    DO I=1,LENGTHX
	      IF (ARRAY2(I,J).NE.0.0) ARRAY2(I,J)=ARRAY2(I,J)-SKY_ABS
	    END DO
	  END DO
C
	ELSE IF (COMMAND.EQ.'MA'.OR.COMMAND.EQ.'MB') THEN !  Manual input of
							  !  data
	  FORESHORT=SQRT(1.0-ECCENTR_ABS**2)
	  CS=COSD(INCLINA_ABS)
	  SN=SIND(INCLINA_ABS)
	  DO J=1,LENGTHY
	    DO I=1,LENGTHX
C  X and Y are the coordinates of the center of the pixel (0.5,0.5)
C  to be written to, relative to the center of the galaxy.
	      X=FLOATJ(MNCOLUMN+I)-COLUMN_ABS-0.5
	      Y=FLOATJ(MNROW+J)-ROW_ABS-0.5
	      SEMIMAJAX=SQRT((X*CS+Y*SN)**2+(-X*SN+Y*CS)**2/FORESHORT
	1     **2)
C  The surface brightness information is in the array ARRAYOUT_ABS
C  when convolution is asked for and then only at integral pixel locations.
C  More accuracy is obtained by calling FAKGALFUN when convolution is not
C  required.
	      IF (CONVOLVE) THEN
	        CALL POLINTERP1D(RADIUSOUT,ARRAYOUT_ABS,NPTS_ABS,SEMIMAJAX,
	1       ADU,2,1,COEFF)
	      ELSE
	        CALL FAKGALFUN(CHOICE_ABS,PARAMETRS_ABS,SEMIMAJAX,
	1       GRADIENT,GRADPARAM,ADU)
C	        ARRAY2(I,J)=ADU
	      END IF
	      ARRAY2(I,J)=ADU !  Inserted here, D.H.G. Feb. 18, 2008
	    END DO
	  END DO
C  Rewrite the pixels corresponding to the center of the galaxy because
C  their values should be an average of the surface brightness over their
C  own areas.
	  DO IY=-2,2
	    DO IX=-2,2 !  25 Central pixels
	      ADU=0.0
	      DO J=1,10
	        DO I=1,10
	          X=IX+AINT(COLUMN_ABS)-COLUMN_ABS+(FLOATJ(I)-0.5)/10.0
	          Y=IY+AINT(ROW_ABS)-ROW_ABS+(FLOATJ(J)-0.5)/10.0
	          SEMIMAJAX=SQRT((X*CS+Y*SN)**2+(-X*SN+Y*CS)**2/FORESHORT
	1         **2)
	          CALL FAKGALFUN(CHOICE_ABS,PARAMETRS_ABS,SEMIMAJAX,
	1         GRADIENT,GRADPARAM,TERM)
	          ADU=ADU+TERM
  	        END DO
	      END DO
	      IXARRAY=IX+JINT(COLUMN_ABS-FLOAT(MNCOLUMN)+1.0)
	      IYARRAY=IY+JINT(ROW_ABS-FLOAT(MNROW)+1.0)
	      IF (IXARRAY.GE.1.AND.IXARRAY.LE.LENGTHX.AND.IYARRAY.GE.1
	1     .AND.IYARRAY.LE.LENGTHY) ARRAY2(IXARRAY,IYARRAY)=ADU/100.0
	    END DO
	  END DO
	END IF
	RETURN
	END
