	REAL*8 FUNCTION GAUSS(PARAMETRS,X)
C
C       This function evaluates a one-dimensional gaussian.
C					Donald H. Gudehus, February, 1987
C
C	PARAMETRS (C)	An array containing the parameters of the
C			gaussian, ie.,
C			PARAMETRS(1)	The central value
C			PARAMETRS(2)	The sigma
C			PARAMETRS(3)	The offset
C			PARAMETRS(4)	The constant term
C	X	  (C)	The dependent variable
C
	DOUBLE PRECISION  PARAMETRS(1),X
C
	GAUSS=(X-PARAMETRS(3))/PARAMETRS(2)
	IF (ABS(GAUSS).GT.13.0) THEN
	  GAUSS=PARAMETRS(4)  ! The constant term to avoid overflow
	ELSE
	  GAUSS=PARAMETRS(1)/EXP(0.5*GAUSS**2)+PARAMETRS(4)
	END IF
	RETURN
	END
