	SUBROUTINE MNMXME2D(ARRAY,NX,NY,EXCLUDE,ARRAYMIN,ARRAYMAX,IMIN,IMAX,
	1JMIN,JMAX,MEAN)
C
C       This subroutine finds the minimum, maximum, their respective
C  indexes, and the mean from a two-dimensional array of values, excluding
C  from consideration, values equal to 7FFFFFFF in hex.
C				Donald H. Gudehus, January, 1987
C			Version 1U, Donald H. Gudehus, Feb. 1, 2008
C			Converted to Unix
C
C	EXCLUDE		(C)	A flag such that when true, zero values are
C				excluded from the computation.
C
	DIMENSION ARRAY(NX,NY)
	LOGICAL EXCLUDE
	REAL MEAN
	DATA END/'FF7FFFFF'X/
C
	IF (.NOT.EXCLUDE) THEN
	  DO WHILE(.TRUE.)
	    DO JJ=1,NY
	      DO II=1,NX
	        IF (ARRAY(II,JJ).NE.END) GO TO 100
	      END DO
	    END DO
	  END DO
	ELSE
	  DO WHILE(.TRUE.)
	    DO JJ=1,NY
	      DO II=1,NX
	        IF (ARRAY(II,JJ).NE.END.AND.ARRAY(II,JJ).NE.0.0) GO TO 100
	      END DO
	    END DO
	  END DO
	END IF
 100	ARRAYMIN=ARRAY(II,JJ)
	ARRAYMAX=ARRAY(II,JJ)
	MEAN=ARRAY(II,JJ)
	IMIN=II
	IMAX=II
	JMIN=JJ
	JMAX=JJ
	MEAN=0.0
	ICOUNT=0
	DO J=1,NY
	  DO I=1,NX
	    IF ((EXCLUDE.AND.ARRAY(I,J).NE.0.0).OR..NOT.EXCLUDE) THEN
 	      IF (ARRAY(I,J).LT.ARRAYMIN.AND.ARRAY(I,J).NE.END) THEN
	        ARRAYMIN=ARRAY(I,J)
	        IMIN=I
	        JMIN=J
	      ELSE IF (ARRAY(I,J).GT.ARRAYMAX.AND.ARRAY(I,J).NE.END) THEN
	        ARRAYMAX=ARRAY(I,J)
	        IMAX=I
	        JMAX=J
	      END IF
	      IF (ARRAY(I,J).NE.END) THEN
	        MEAN=MEAN+ARRAY(I,J)
	        ICOUNT=ICOUNT+1
	      END IF
	    END IF
	  END DO
	END DO
	MEAN=MEAN/FLOAT(ICOUNT)
	RETURN
	END
