	SUBROUTINE NLFUN1(RADIUS,MAXNPOINTS,DIMENSN_IND,PARAMETRS,CHOICE,
	1OPERATE,IRADII,FUNCTN,DIMENSN_DATA)
C
C       This subroutine helps NONLINFIT by selecting the chosen galaxy
C  fitting function, evaluating it taking into account a user defined
C  operation if necessary, and returning the answer.  Here we evaluate
C  fitting funtctions for the surface brightness distribution of galaxies.
C  
C			Donald H. Gudehus, March, 1986
C
C	RADIUS		(C)	The array containing the independent variable
C				values
C	MAXNPOINTS	(C)	The first dimension of the array RADIUS
C	DIMENSN_IND	(C)	The second dimension of the array RADIUS
C	PARAMETRS	(C)	The array containing the parameters used to
C				evaluate the function
C	CHOICE		(C)	The choice determining which function
C				to use within a category
C	OPERATE		(C)	A logical key which determines what to do.
C				If .FALSE., the function is evaluated, if 
C				.TRUE., a user defined operation is carried
C				out, e.g., convolution.
C	IRADII		(C)	An array containing the starting and ending
C				indexes for the evaluation of of FUNCTN
C	FUNCTN		(R)	The output array containing the function.
C	DIMENSN_DATA	(C)	The second dimension of the output array
C
	INCLUDE 'miipspar.for'
C
	CHARACTER*(*) CHOICE
C
	INTEGER DIMENSN_IND,DIMENSN_DATA,FUNCAT,IRADII(2)
C
	LOGICAL OPERATE,PLOT
C
	REAL*8 RADIUS(MAXNPOINTS,DIMENSN_IND),PARAMETRS(1),
	1FUNCTN(MAXNPOINTS,DIMENSN_DATA),MCFACTOR,VFACTOR
C
C
	INTEGER NPOINTS_S,NPOINTS_FIT,NPOINTS_C,IRADIICONVOLVE(2)
	COMMON /NLF1_INTEGER_SCRATCH_BLOCK/ NPOINTS_S,NPOINTS_FIT,NPOINTS_C,
	1IRADIICONVOLVE
C
	REAL RADIUSINC(MAXDIAG),SURFBNOTC(MAXDIAG),
	1SMEAR(MAXDIAG),SURFBCONVOLVE(MAXDIAG),RADII(2),CONVOLVEFACTOR,
	2RADIUS_C
	COMMON /NLF1_REAL4_SCRATCH_BLOCK/ RADIUSINC,SURFBNOTC,
	1SMEAR,SURFBCONVOLVE,RADII,CONVOLVEFACTOR,RADIUS_C
C
	MCFACTOR=0.4*LOG(10.0)
	CALL ALPHA(%REF(CHOICE),1,LEN(CHOICE),NCHAR,NFULL,NREST,1)
	PLOT=.FALSE.
	IF (CHOICE(NCHAR:NCHAR).EQ.'%') THEN
	  PLOT=.TRUE.
	  CHOICE(NCHAR:NCHAR)=' '
	END IF
	IF (OPERATE) THEN !  Convolution
	  IRADIICONVOLVE(1)=IRADII(1)
	  RADIUSINC(1)=RADIUS(1,1)
	  IF (RADIUSINC(1).NE.0.0) THEN
	    CALL ERROR(-1,'The object to be convolved does not
	1 begin at its center')
	  END IF
	  I=1
	  IF (CHOICE.EQ.'G'.OR.CHOICE.EQ.'H'.OR.CHOICE.EQ.'M'
	1 .OR.CHOICE.EQ.'MC'.OR.CHOICE.EQ.'T'.OR.CHOICE
	2 .EQ.'HV') THEN
C  Set up RADIUSINC with smaller increments near the center of
C  the galaxy.
	    DO WHILE ((RADIUSINC(I).LT.MAX(RADII(2),RADIUS_C)
	1   +1.0).AND.(I.LT.MAXDIAG)) !  One larger than outer radius
				      !  for interpolation in CONVLV2DG
	      RADIUSINC(I+1)=RADIUSINC(I)+MIN(1.0D0,
	1     MAX(0.001D0,(1.0+RADIUSINC(I)/PARAMETRS(2))**2*
	1     PARAMETRS(2)/CONVOLVEFACTOR))
	      I=I+1
	    END DO
	    NANGLES=24+INT((1.0-(MIN(10.0D0,PARAMETRS(2))+10.0)/20.0)*
	1   96.0)
	  ELSE IF (CHOICE.EQ.'V'.OR.CHOICE.EQ.'VC') THEN
	    DO WHILE (RADIUSINC(I).LT.MAX(RADII(2),RADIUS_C)
	1   +1.0)
	      RADIUSINC(I+1)=RADIUSINC(I)+MIN(1.0D0,
	1     MAX(0.001D0,(1.0+RADIUSINC(I)*10.0/PARAMETRS(2))**2*
	1     (PARAMETRS(2)/10.0)/CONVOLVEFACTOR))
	      I=I+1
	    END DO
	    NANGLES=24+INT((1.0-(MIN(10.0D0,PARAMETRS(2)/10.0)+10.0)/20.0)
	1   *96.0)
	  ELSE
	    DO WHILE (RADIUSINC(I).LT.MAX(RADII(2),RADIUS_C)
	1   +1.0)
	      RADIUSINC(I+1)=RADIUSINC(I)+1.0
	      I=I+1
	    END DO
	    NANGLES=24
	  END IF
	  IRADIICONVOLVE(2)=I-1
C  Evaluate the formula at the precomputed radii
	  IF (CHOICE.EQ.'G') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=RADIUSINC(N)/PARAMETRS(2)
	      IF (SURFBNOTC(N).GT.13.0) THEN
	        SURFBNOTC(N)=PARAMETRS(3)
	      ELSE
	        SURFBNOTC(N)=PARAMETRS(1)/EXP(0.5*SURFBNOTC(N)**2)+PARAMETRS(3)
	      END IF
	    END DO
	  ELSE IF (CHOICE.EQ.'H'.OR.CHOICE.EQ.'M'.OR.CHOICE.EQ.'MC') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      IF (PARAMETRS(1).LT.0.0) PARAMETRS(1)=-0.5*PARAMETRS(1)
	      IF (PARAMETRS(2).LT.0.0) PARAMETRS(2)=-0.5*PARAMETRS(2)
	      IF (CHOICE.EQ.'H'.OR.(CHOICE(1:1).EQ.'M'.AND.RADIUSINC(N)/
	1     PARAMETRS(2).LE.21.4)) THEN
	        SURFBNOTC(N)=PARAMETRS(1)/(1.0+RADIUSINC(N)/PARAMETRS(2))**2
	      ELSE
	        SURFBNOTC(N)=22.4*PARAMETRS(1)/(1.0+RADIUSINC(N)/
	1       PARAMETRS(2))**3
	      END IF
	      IF (CHOICE.EQ.'MC') THEN
	        IF (PARAMETRS(3).LT.0.0) PARAMETRS(3)=-0.5*PARAMETRS(3)
	        IF (PARAMETRS(4).LT.0.0) PARAMETRS(4)=-0.5*PARAMETRS(4)
	        IF (RADIUSINC(N)/PARAMETRS(4).LE.21.4) THEN
	          SURFBNOTC(N)=SURFBNOTC(N)+PARAMETRS(3)/(1.0+RADIUSINC(N)/
	1         PARAMETRS(4))**2+PARAMETRS(5)
	        ELSE
	          SURFBNOTC(N)=SURFBNOTC(N)+22.4*PARAMETRS(3)/
	1         (1.0+RADIUSINC(N)/PARAMETRS(4))**3+PARAMETRS(5)
	        END IF
	      ELSE
	        SURFBNOTC(N)=SURFBNOTC(N)+PARAMETRS(3)
	      END IF
	    END DO
	  ELSE IF (CHOICE.EQ.'HV') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=PARAMETRS(1)/(1.0+RADIUSINC(N)/PARAMETRS(2))
	1     **PARAMETRS(3)+PARAMETRS(4)
	    END DO
	  ELSE IF (CHOICE.EQ.'I') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=PARAMETRS(1)/RADIUSINC(N)**PARAMETRS(2)+PARAMETRS(3)
	    END DO
	  ELSE IF (CHOICE.EQ.'K') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=PARAMETRS(1)
	    END DO
	  ELSE IF (CHOICE.EQ.'L') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=PARAMETRS(1)+PARAMETRS(2)*RADIUSINC(N)
	    END DO
	  ELSE IF (CHOICE.EQ.'SI') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=PARAMETRS(1)/RADIUSINC(N)+PARAMETRS(2)/
	1     RADIUSINC(N)**2+PARAMETRS(3)
	    END DO
	  ELSE IF (CHOICE.EQ.'T') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=(PARAMETRS(1)/(1.0+RADIUSINC(N)/
	1     ABS(PARAMETRS(2)))**2)
	1     *EXP(-(RADIUSINC(N)/ABS(PARAMETRS(3)))**ABS(PARAMETRS(4)))+
	1     PARAMETRS(5)
	    END DO
	  ELSE IF (CHOICE.EQ.'V'.OR.CHOICE.EQ.'VC') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=PARAMETRS(1)*10.0**(-3.33*((RADIUSINC(N)/
	1     PARAMETRS(2))**0.25-1.0))
	      IF (CHOICE.EQ.'VC') THEN
	        SURFBNOTC(N)=SURFBNOTC(N)+PARAMETRS(3)/(1.0+RADIUSINC(N)/
	1       PARAMETRS(4))**2+PARAMETRS(5)
	      ELSE
	        SURFBNOTC(N)=SURFBNOTC(N)+PARAMETRS(3)
	      END IF
	    END DO
	  ELSE IF (CHOICE.EQ.'E3') THEN
	    DO N=IRADIICONVOLVE(1),IRADIICONVOLVE(2)
	      SURFBNOTC(N)=PARAMETRS(1)+(3.0069930-2.91916030*
	1     LOG10(RADIUSINC(N)/PARAMETRS(2))+0.876610572*(LOG10(RADIUSINC(N)
	2     /PARAMETRS(2)))**2
	3     -0.030263527*(LOG10(RADIUSINC(N)/PARAMETRS(2)))**3
	4     -0.0166767680*(LOG10(RADIUSINC(N)/PARAMETRS(2)))**4)
	    END DO
	  END IF
	  CALL CONVLV2DG(SURFBNOTC,RADIUSINC,MAXDIAG,
	1 SMEAR,NPOINTS_S,SURFBCONVOLVE,MAX(NPOINTS_FIT,NPOINTS_C),
	2 NPOINTS_C,NANGLES)
	  DO N=1,MAX(NPOINTS_FIT,NPOINTS_C)
	    FUNCTN(N,1)=SURFBCONVOLVE(N)
	  END DO
C
	ELSE !  No convolution
	  IF (CHOICE.EQ.'G') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=RADIUS(N,1)/PARAMETRS(2)
	      IF (FUNCTN(N,1).GT.13.0) THEN
	        FUNCTN(N,1)=PARAMETRS(3)
	      ELSE
	        FUNCTN(N,1)=PARAMETRS(1)/EXP(0.5*FUNCTN(N,1)**2)+PARAMETRS(3)
	      END IF
	    END DO
	  ELSE IF (CHOICE.EQ.'H'.OR.CHOICE.EQ.'M'.OR.CHOICE.EQ.'MC') THEN
	    DO N=IRADII(1),IRADII(2)
	      IF (PARAMETRS(1).LT.0.0) PARAMETRS(1)=-0.5*PARAMETRS(1)
	      IF (PARAMETRS(2).LT.0.0) PARAMETRS(2)=-0.5*PARAMETRS(2)
	      IF (CHOICE.EQ.'H'.OR.(CHOICE(1:1).EQ.'M'.AND.RADIUS(N,1)/
	1     PARAMETRS(2).LE.21.4)) THEN
	        FUNCTN(N,1)=PARAMETRS(1)/(1.0+RADIUS(N,1)/PARAMETRS(2))**2
	      ELSE
	        FUNCTN(N,1)=22.4*PARAMETRS(1)/(1.0+RADIUS(N,1)/
	1       PARAMETRS(2))**3
	      END IF
	      IF (CHOICE.EQ.'MC') THEN
	        IF (PARAMETRS(3).LT.0.0) PARAMETRS(3)=-0.5*PARAMETRS(3)
	        IF (PARAMETRS(4).LT.0.0) PARAMETRS(4)=-0.5*PARAMETRS(4)
	        IF (RADIUS(N,1)/PARAMETRS(4).LE.21.4) THEN
	          FUNCTN(N,1)=FUNCTN(N,1)+PARAMETRS(3)/(1.0+RADIUS(N,1)/
	1         PARAMETRS(4))**2+PARAMETRS(5)
	        ELSE
	          FUNCTN(N,1)=FUNCTN(N,1)+22.4*PARAMETRS(3)/
	1         (1.0+RADIUS(N,1)/PARAMETRS(4))**3+PARAMETRS(5)
	        END IF
	      ELSE
	        FUNCTN(N,1)=FUNCTN(N,1)+PARAMETRS(3)
	      END IF
	    END DO
	  ELSE IF (CHOICE.EQ.'HV') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)/(1.0+RADIUS(N,1)/PARAMETRS(2))
	1     **PARAMETRS(3)+PARAMETRS(4)
	    END DO
	  ELSE IF (CHOICE.EQ.'I') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)/RADIUS(N,1)**PARAMETRS(2)+PARAMETRS(3)
	    END DO
	  ELSE IF (CHOICE.EQ.'K') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)
	    END DO
	  ELSE IF (CHOICE.EQ.'L') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)+PARAMETRS(2)*RADIUS(N,1)
	    END DO
	  ELSE IF (CHOICE.EQ.'SI') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)/RADIUS(N,1)+PARAMETRS(2)/
	1     RADIUS(N,1)**2+PARAMETRS(3)
	    END DO
	  ELSE IF (CHOICE.EQ.'T') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=(PARAMETRS(1)/(1.0+RADIUS(N,1)/
	1     ABS(PARAMETRS(2)))**2)
	1     *EXP(-(RADIUS(N,1)/ABS(PARAMETRS(3)))**ABS(PARAMETRS(4)))+
	1     PARAMETRS(5)
	    END DO
	  ELSE IF (CHOICE.EQ.'V'.OR.CHOICE.EQ.'VC') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)*10.0**(-3.33*((RADIUS(N,1)/
	1     PARAMETRS(2))**0.25-1.0))
	      IF (CHOICE.EQ.'VC') THEN
	        FUNCTN(N,1)=FUNCTN(N,1)+PARAMETRS(3)/(1.0+RADIUS(N,1)/
	1       PARAMETRS(4))**2+PARAMETRS(5)
	      ELSE
	        FUNCTN(N,1)=FUNCTN(N,1)+PARAMETRS(3)
	      END IF
	    END DO
	  ELSE IF (CHOICE.EQ.'E3') THEN
	    DO N=IRADII(1),IRADII(2)
	      FUNCTN(N,1)=PARAMETRS(1)+(3.0069930-2.91916030*
	1     LOG10(RADIUS(N,1)/PARAMETRS(2))+0.876610572*(LOG10(RADIUS(N,1)
	2     /PARAMETRS(2)))**2
	3     -0.030263527*(LOG10(RADIUS(N,1)/PARAMETRS(2)))**3
	4     -0.0166767680*(LOG10(RADIUS(N,1)/PARAMETRS(2)))**4)
	    END DO
	  END IF
	END IF
C
	RETURN
	END
