	FUNCTION OPTION_PARAM(OPT,N,N1,N2,N3)
C
C       This function finds the position of the current option and its 
C  parameters.
C
C			Version 2, Donald H. Gudehus
C			Declared OPTION_PARAM as logical.
C			The absence of this declaration created some
C			problems in drawing vectors on SAOimage under
C			Unix.
C	
C	OPT is the input character string.
C	N	(C)	the position in the string to start the search.
C	N1	(R)	the position of the start of the current option.
C	N2	(R)	the position of the end of the current option.
C	N3	(R)	the position of the end of the parameter list.
C
C	OPTION_PARAM has the value true if no errors occur.
C
C
	CHARACTER*(*) OPT
C
	LOGICAL OPTION_PARAM
C
	OPTION_PARAM=.FALSE.
	NL=LEN(OPT)
C  Find start
	N1=N
	IF (OPT(N1:N1).EQ.' ') N1=N1+1
C  Find end of opt and parameters
	NA=INDEX(OPT(N1:),' ')		!  next separator
	NB=INDEX(OPT(N1:),'(')		!  next (
	IF (NB.EQ.0.OR.NB.GT.NA) THEN	!  no parameters on this option
	  N2=NA+N1-2
	  N3=N2
	ELSE !  parameters present
	  N2=NB+N1-2
	  N3=INDEX(OPT(N2:),')')+N2-1
	  IF (N3.EQ.0) N3=NL !  ) missing
	END IF
C
	OPTION_PARAM=.TRUE. !  No errors
	RETURN
	END
