	SUBROUTINE PROBABLE2DS(LU,DATA,NX,NY,ISX,ISY,IBIN,NBINS,EXCLUDE,
	1PROBABLE_VAL,SIGMA)
C
C	Note:  This is the Unix version
C
C       This subroutine helps STATS, CUTOFF, MFLAT, and SKYBACK by allowing
C  operation of the dynamic memory and reading of a FITS file.  It then calls
C  PROBABLE2D to return the most probable value and the sigma.
C					Donald H. Gudehus, January, 1987
C					Version 1U, D. H. Gudehus, January 25, 2008
C					Converted the code to work under Unix and
C					with FITS files.
C
C	LU		(C)	The logical unit
C	DATA		(C)	The array
C	NX		(C)	Dimension in the X direction and the number of
C				pixels to be read
C	NY		(C)	Dimension in the Y direction and the number of
C				pixels to be read
C	ISX		(C)	The starting column in the map
C	ISY		(C)	The starting row in the map
C	EXCLUDE		(C)	A key such that when true, values of zero are
C				excluded from the computation
C	PROBABLE_VAL	(R)	The most probable value of the pixels in the
C				array
C	SIGMA		(R)	The mean error
C
	DIMENSION DATA(NX,NY),IBIN(NBINS)
	REAL*8 PROBABLE_VAL,SIGMA
	LOGICAL EXCLUDE
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL RDFITSXY(LU,IMNUM,IPNUM,DATA,NX,NY,ISX,NX,ISY,NY)
	CALL PROBABLE2D(DATA,NX,NY,IBIN,NBINS,EXCLUDE,PROBABLE_VAL,SIGMA)
C
	RETURN
	END
