	SUBROUTINE RADGALIT(FIRSTIME,PARAMETRS,PARAMETRS_INIT,
	1NUMPARAM,SIGMA,SIGMA_INIT,TOLERANCE,FRACINCR,ITERATION_SCHEME,
	2CHOICE,ITERATE)
C
C       This subroutine helps RADGAL by determining when to stop
C  iterating and by computing the value of the fractional
C  increment based on the relative change in the sigma of the fit
C  and readjusting the parameters to a value weighted by their former
C  value if the sigma increases.
C				Donald H. Gudehus, March, 1984
C
	DIMENSION PARAMETRS(6),PARAMETRS_INIT(6),PARAMETRS_PRIOR(6),
	1PARAMETRS_BEST(6)
	CHARACTER*1 ITERATION_SCHEME
	CHARACTER*6 CHOICE
	LOGICAL FIRSTIME,ITERATE
C
	IF (FIRSTIME) THEN
	  SIGMA_PRIOR=SIGMA_INIT
	  SIGMA_BEST=SIGMA_INIT
	  DO I=1,NUMPARAM
	    PARAMETRS_PRIOR(I)=PARAMETRS_INIT(I)
	    PARAMETRS_BEST(I)=PARAMETRS_INIT(I)
	  END DO
	END IF
	IF (ITERATION_SCHEME.EQ.'A'.OR.ITERATION_SCHEME.EQ.'B'.OR.
	1ITERATION_SCHEME.EQ.'C') THEN
	  ITERATE=.FALSE.
	  DO I=1,NUMPARAM
	    IF (ABS(PARAMETRS(I)-PARAMETRS_PRIOR(I)).GE.
	1   ABS(PARAMETRS(I))*TOLERANCE) ITERATE=.TRUE.
	  END DO
	END IF
	IF (.NOT.FIRSTIME) THEN
	  DO I=1,NUMPARAM
	    PARAMETRS_PRIOR(I)=PARAMETRS(I)
	  END DO
	END IF
C
	IF (SIGMA.LT.SIGMA_BEST) THEN
	  SIGMA_BEST=SIGMA
	  DO I=1,NUMPARAM
	    PARAMETRS_BEST(I)=PARAMETRS(I)
	  END DO
	END IF
	IF (ITERATION_SCHEME.EQ.'A'.OR.ITERATION_SCHEME.EQ.'B') THEN
	  IF (SIGMA.GT.SIGMA_PRIOR) THEN
	    FRACINCR=0.67*FRACINCR
	    DO I=1,NUMPARAM
	      IF (ITERATION_SCHEME.EQ.'A') THEN
	        PARAMETRS(I)=PARAMETRS_BEST(I)*(1.0-FRACINCR)+
	1       PARAMETRS(I)*FRACINCR
	      ELSE IF (ITERATION_SCHEME.EQ.'B') THEN
	        PARAMETRS(I)=PARAMETRS_BEST(I)
	      END IF
	    END DO
	  END IF
	ELSE IF (ITERATION_SCHEME.EQ.'C') THEN
	  IF (SIGMA.GT.SIGMA_BEST) THEN
	    FRACINCR=0.67*FRACINCR
	    DO I=1,NUMPARAM
	      PARAMETRS(I)=PARAMETRS_BEST(I)
	    END DO
	  END IF
	ELSE IF (ITERATION_SCHEME.EQ.'M'.AND.(CHOICE.NE.'K'.AND.
	1CHOICE.NE.'L')) THEN
	  DO I=1,NUMPARAM
	    PARAMETRS(I)=PARAMETRS_BEST(I)
	  END DO
	  ITERATE=.TRUE.
	  CALL USRINP(ITERATE,1,'L',1,1,'ITERATE=',
	1 'Do you wish to iterate 1 more time?  (default = Y)')
	  IF (ITERATE) THEN
	    FRACINCR=0.67*FRACINCR
	    CALL USRINP(FRACINCR,1,'F',4,1,
	1   'FRACTIONAL_INCREMENT=','Enter the fractional
	2 increment:  (default = 0.67xlast value)')
	    CALL USRINP(PARAMETRS,NUMPARAM,'F',4,1,'PARAMETERS=',
	1   'Enter the new estimates:  (default = best values)')
	  END IF
	END IF
	SIGMA_PRIOR=SIGMA
C
	RETURN
	END
