	SUBROUTINE RDDATFL1A(LU,ID,PARAM_PRF,MAXSIZE,NPTS,
	1INDEXMINUSRADIUS)
C
C       This subroutine reads a data file of type 1, previously
C  opened on logical unit LU, searches for the object identified by
C  the name ID, fills the array PARAM_PRF with the data,
C  and returns the number of points for that object and the index minus
C  the radius.  This subroutine is similar to RDDATFL1 except for the
C  dimensioning of PARAM_PRF which in this subroutine is designed for
C  maximum speed when creating aritficial images.
C			Donald H. Gudehus, April, 1984
C			Version 2, Donald H. Gudehus, February 27, 2008
C			Took out IHED for FITS files, and changed CFILE
C
	DIMENSION PARAM_PRF(5,MAXSIZE)
	CHARACTER*6 ID,IDREAD
C
	CHARACTER*80 DCNAME
	COMMON /CFILE/ DCNAME
C
	REAL INCLINA,LOGINTADU,INDEXMINUSRADIUS
C
	REWIND LU
	READ(LU,1100,ERR=14)
	GO TO 16
  14	CALL ERROR(-3,'Couldn''t read the header')
  16	CONTINUE
1100	FORMAT(' ','ID',8X,'COLUMN',5X,'ROW',1X,'INCLINATION',
	11X,'ECCENTRICITY',1X,'RADIUS',5X,'ADU',3X,'LOG(INTEGRAL)')
	IF (ID.EQ.' ') ID='CRAP'
	IDREAD=' '
	DO WHILE (ID.NE.IDREAD)
	  READ(LU,1101,END=22) IDREAD,COLUMN,ROW,INCLINA,ECCENTR,R,
	1 ADU,LOGINTADU
	END DO
	IF (R.NE.0) THEN
	  CALL ALPHA(%REF(DCNAME),1,40,NC,NF,NR,1)
	  WRITE(6,1000) DCNAME
	  WRITE(7,1000) DCNAME
1000	  FORMAT(' File ',A<NC>,' does not begin at the center
	1 of the object')
	END IF
	INDEXMINUSRADIUS=1.0-R
	PARAM_PRF(1,1)=COLUMN
	PARAM_PRF(2,1)=ROW
	PARAM_PRF(3,1)=INCLINA
	PARAM_PRF(4,1)=ECCENTR
	PARAM_PRF(5,1)=ADU
	GO TO 24
  22	CALL ERROR(-3,'Couldn''t find the object')
	RETURN
  24	CONTINUE
	NPTS=1
	DO 40 WHILE (ID.EQ.IDREAD)
	  READ(LU,1101,END=42) IDREAD,COLUMN,ROW,INCLINA,ECCENTR,R,
	1 ADU,LOGINTADU
1101	  FORMAT(' ',A6,1X,F9.3,1X,F9.3,1X,F7.2,6X,F6.3,F8.3,1X,
	1 F13.6,1X,F11.8)
	  NPTS=NPTS+1
	  PARAM_PRF(1,NPTS)=COLUMN
	  PARAM_PRF(2,NPTS)=ROW
	  PARAM_PRF(3,NPTS)=INCLINA
	  PARAM_PRF(4,NPTS)=ECCENTR
	  PARAM_PRF(5,NPTS)=ADU
  40	CONTINUE
	NPTS=NPTS-1  ! Ignore the last number read
  42	CONTINUE
C
	RETURN
	END
