	SUBROUTINE ROTATE1(DATAXY,NI,NJ,NI2,NJ2,THETA,CHOICE,DATA_ROTATE,
	1DATADP_ROTATE,MAXSIZE,ICOMMAND,LU_IN,LU_TEMP,
	2IMNUM_IN,IPNUM_IN)
C
C       This subroutine help ROTATE in carrying out a FITS file
C  rotation.
C			Donald H. Gudehus, February, 2008
C
	CHARACTER*1 CHOICE
C
	INTEGER NI,NJ,NI2,NJ2,ICOMMAND,LU_IN,LU_TEMP,IMNUM_IN,IPNUM_IN
C
	REAL*4 DATAXY(NI,NJ),THETA,DATA_ROTATE(MAXSIZE)
	REAL*4 INTERP2D
	REAL*8 DATADPXY(NI,NJ),DATADP_ROTATE(MAXSIZE),INTERPDP2D
C
C
	CHARACTER*3 PRGFMAT
C
	REAL*4 C,S,CENTER1(2),CENTER2(2)
C
	CHARACTER*80 DNAME
	COMMON /DFILE/ DNAME
C
	ENTRY ROTATE1SP(DATAXY,NI,NJ,NI2,NJ2,THETA,CHOICE,DATA_ROTATE,
	1DATADP_ROTATE,MAXSIZE,ICOMMAND,LU_IN,LU_TEMP,
	2IMNUM_IN,IPNUM_IN)
	PRGFMAT='R4'
	GO TO 100
C
	ENTRY ROTATE1DP(DATADPXY,NI,NJ,NI2,NJ2,THETA,CHOICE,DATA_ROTATE,
	1DATADP_ROTATE,MAXSIZE,ICOMMAND,LU_IN,LU_TEMP,
	2IMNUM_IN,IPNUM_IN)
	PRGFMAT='R8'
	GO TO 100
C
 100	CONTINUE
	IF (PRGFMAT.EQ.'R4') THEN
	  CALL RDFITSXY(LU_IN,IMNUM_IN,IPNUM_IN,DATAXY,NI,NJ,
	1 1,NI,1,NJ)
	  IF (ICOMMAND.EQ.2) THEN !  90 Degrees Clockwise
C  Loop on the output rows
	    DO IR=1,NJ2
C  Compute the column in the array of the input map to read.
C  Start at the right side.
	      ICOL=NI-IR+1
C  Load the output row-array
	      DO I=1,NI2
	        DATA_ROTATE(I)=DATAXY(ICOL,I)
	      END DO
	      CALL WRFITSROW(LU_TEMP,IMNUM_IN,IPNUM_IN,DATA_ROTATE,MAXSIZE,IR)
	    END DO
	  ELSE IF (ICOMMAND.EQ.3) THEN !  90 Degrees Counterclockwise
C  Loop on the output rows
	    DO IR=1,NJ2
C  Compute the column in the array of the input map to read.
C  Start at the left side.
	      ICOL=IR
C  Load the output row-array
	      DO I=1,NI2
	        II=NJ-I+1
	        DATA_ROTATE(I)=DATAXY(ICOL,II)
	      END DO
	      CALL WRFITSROW(LU_TEMP,IMNUM_IN,IPNUM_IN,DATA_ROTATE,MAXSIZE,IR)
	    END DO
	  ELSE IF (ICOMMAND.EQ.4) THEN !  Arbitrary angle
	    C=COSD(THETA)
	    S=SIND(THETA)
C  We want CENTER2 to be at the center of a pixel
	    CENTER1(1)=(NI+2.0)/2.0
	    CENTER1(2)=(NJ+2.0)/2.0
	    CENTER2(1)=(NI2+2.0)/2.0
	    CENTER2(2)=(NJ2+2.0)/2.0
C  If CHOICE is K, the above will not yield the center of a pixel if the 
C  original length is even.  Therefore we shift the center by half a pixel.
	    IF (CHOICE.EQ.'K') THEN
	      IF (NI2/2.0-INT(NI2/2.0).EQ.0.0) CENTER2(1)=CENTER2(1)+0.5
	      IF (NJ2/2.0-INT(NJ2/2.0).EQ.0.0) CENTER2(2)=CENTER2(2)+0.5
	    END IF
	    DO J=1,NJ2
C YNEW and XNEW will be at the centers of the pixels
	      YNEW=FLOAT(J)-CENTER2(2)
	      DO 50 I=1,NI2
	        XNEW=I-CENTER2(1)
	        XOLD=C*XNEW+S*YNEW+CENTER1(1)
	        YOLD=-S*XNEW+C*YNEW+CENTER1(2)
	        IF (XOLD.LT.1.5.OR.XOLD.GT.FLOAT(NI)+0.5.OR.YOLD.LT.1.5.OR.
	1       YOLD.GT.FLOAT(NJ)+0.5) THEN
	          DATA_ROTATE(I)=0.0
	          GO TO 50
	        END IF
	        DATA_ROTATE(I)=INTERP2D(DATAXY,NI,NJ,XOLD,YOLD)
  50	      CONTINUE
	      CALL WRFITSROW(LU_TEMP,IMNUM_IN,IPNUM_IN,DATA_ROTATE,MAXSIZE,J)
	    END DO
	  END IF
	ELSE IF (PRGFMAT.EQ.'R8') THEN
	  CALL RDDPFITSXY(LU_IN,IMNUM_IN,IPNUM_IN,DATADPXY,NI,NJ,
	1 1,NI,1,NJ)
	  IF (ICOMMAND.EQ.2) THEN
C  Loop on the output rows
	    DO IR=1,NJ2
C  Compute the column in the array of the input map to read.
C  Start at the right side.
	      ICOL=NI-IR+1
C  Load the output row-array
	      DO I=1,NI2
	        DATADP_ROTATE(I)=DATADPXY(ICOL,I)
	      END DO
	      CALL WRDPFITSROW(LU_TEMP,IMNUM_IN,IPNUM_IN,DATADP_ROTATE,
	1     MAXSIZE,IR)
	    END DO
	  ELSE IF (ICOMMAND.EQ.3) THEN
C  Loop on the output rows
	    DO IR=1,NJ2
C  Compute the column in the array of the input map to read.
C  Start at the left side.
	      ICOL=IR
C  Load the output row-array
	      DO I=1,NI2
	        II=NJ-I+1
	        DATADP_ROTATE(I)=DATADPXY(ICOL,II)
	      END DO
	      CALL WRDPFITSROW(LU_TEMP,IMNUM_IN,IPNUM_IN,DATADP_ROTATE,
	1     MAXSIZE,IR)
	    END DO
	  ELSE IF (ICOMMAND.EQ.4) THEN !  Arbitrary angle
	    C=COSD(THETA)
	    S=SIND(THETA)
C  We want CENTER2 to be at the center of a pixel
	    CENTER1(1)=(NI+2.0)/2.0
	    CENTER1(2)=(NJ+2.0)/2.0
	    CENTER2(1)=(NI2+2.0)/2.0
	    CENTER2(2)=(NJ2+2.0)/2.0
C  If CHOICE is K, the above will not yield the center of a pixel if the 
C  original length is even.  Therefore we shift the center by half a pixel.
	    IF (CHOICE.EQ.'K') THEN
	      IF (NI2/2.0-INT(NI2/2.0).EQ.0.0) CENTER2(1)=CENTER2(1)+0.5
	      IF (NJ2/2.0-INT(NJ2/2.0).EQ.0.0) CENTER2(2)=CENTER2(2)+0.5
	    END IF
	    DO J=1,NJ2
C YNEW and XNEW will be at the centers of the pixels
	      YNEW=FLOAT(J)-CENTER2(2)
	      DO 55 I=1,NI2
	        XNEW=I-CENTER2(1)
	        XOLD=C*XNEW+S*YNEW+CENTER1(1)
	        YOLD=-S*XNEW+C*YNEW+CENTER1(2)
	        IF (XOLD.LT.1.5.OR.XOLD.GT.FLOAT(NI)+0.5.OR.YOLD.LT.1.5.OR.
	1       YOLD.GT.FLOAT(NJ)+0.5) THEN
	          DATA_ROTATE(I)=0.0
	          GO TO 50
	        END IF
	        DATADP_ROTATE(I)=INTERPDP2D(DATADPXY,NI,NJ,XOLD,YOLD)
  55	      CONTINUE
	      CALL WRDPFITSROW(LU_TEMP,IMNUM_IN,IPNUM_IN,DATADP_ROTATE,
	1     MAXSIZE,J)
	    END DO
	  END IF
	END IF
C
	RETURN
	END
