	SUBROUTINE SAO_IMAGPROC
C
C       This subroutine allows one to manipulate pictures on SAOimage.
C  After the picture has been loaded with option TV, this option allows 
C  reading of cursor locations, reading of pixel values, computation of 
C  statistics, and alteration of look up table and color gun logic. 
C  The object code for this module belongs in the PAN library.
C			Donald H. Gudehus, August, 1993
C			Version 2, D. H. G., June 29, 1995
C			Added command X.
C			Version 3, D. H. G., June 24, 1999
C			Initialized XAXIS_OFFSET and YAXIS_OFFSET, and
C			added annotation and drawing
C			Version 3U, D. H. G., February 3, 2008
C			Converted to Unix and FITS
C			
C
	INCLUDE 'miipspar.for'
	INCLUDE 'saofacts.for'
	INCLUDE 'plotpar.for'
C
	CHARACTER*4 COMMAND
	CHARACTER*132 STRING
	COMMON /CHAR_SCRATCH_BLOCK/ COMMAND,STRING
C
C	INTEGER ZERO,RD,GRN,BLU
	INTEGER BLUE(0:199),GREEN(0:199),RED(0:199),TEMPCOLOR
	COMMON /INTEGER4_SCRATCH_BLOCK/ LX,NF,NR,IX,IY,NPIC1,NPIC2
C
	REAL*4 DATA(MAXSIZE)
	REAL*4 ANNOTATION_HEIGHT
	COMMON /REAL4_SCRATCH_BLOCK/ DATA,ANNOTATION_HEIGHT
C
	LOGICAL MESSAG
C
	ANNOTATION_HEIGHT=0.14
 	DO WHILE(.TRUE.)
   5	  COMMAND='H'
	  CALL USRINP(%REF(COMMAND),1,'A',4,1,'COMMAND=','Enter a command:'//
	1 '  (H for help, default)')
	  CALL ALPHA(%REF(COMMAND),1,4,LX,NF,NR,2)
	  IF (COMMAND.EQ.'A') THEN
	    IF (IFB_SAO.NE.2) THEN
	      CALL MESSAGE('An 800x800 buffer is required for annotation')
	      GO TO 5
	    END IF
	    CALL PLTDEV(-13) !  Doesn't erase SAOimage and if channels have
			     !  been assigned, doesn't load a default lookup
			     !  table.
	    CALL COLORMODE(16777419) !  Initializes the overlay color to red
	    ICHAR=0
	    XAXIS_OFFSET=0.0
	    YAXIS_OFFSET=0.0
	    CALL WHERE(XNOW,YNOW,ICHAR)
	    DO WHILE (ICHAR.NE.13.AND.ICHAR.NE.81) !  The letter Q for
						   !  quit or a <CR>
	      IF (ICHAR.EQ.97) THEN !  The letter a for annotation
	        CALL MESSAGE('Annotation requested;  enter H for help')
	        CALL WHERE(XNOW,YNOW,ICHAR1)
	        STRING=' '
	        CALL USRINP(%REF(STRING),1,'A',132,0,'STRING=',
	1       'Enter a string:')
	        CALL ALPHA(%REF(STRING),1,132,NC,NF,NR,1)
	        CALL SYMBOL(XNOW-XAXIS_OFFSET,YNOW-YAXIS_OFFSET,
	1       ANNOTATION_HEIGHT,%REF(STRING),0.0,NC)
	        IA=IA+1
	      ELSE IF (ICHAR.EQ.1) THEN !  Control A for height of annotation
	        CALL MESSAGE('Annotation height requested')
	        ANNOTATION_HEIGHT=0.14
	        CALL USRINP(ANNOTATION_HEIGHT,1,'F',4,1,'HEIGHT=',
	1       'Enter the annotation height in inches:  (default = 0.14)')
	      ELSE IF (ICHAR.EQ.99) THEN !  The letter c for color
	        CALL MESSAGE('Color requested')
	        CALL USRINP(TEMPCOLOR,1,'I',4,0,'COLOR=',
	1       'Enter the color:')
	        CALL COLORMODE(TEMPCOLOR)
	      ELSE IF (ICHAR.EQ.72) THEN !  The letter H for help
C  If a graphics terminal having a separate TEK window exists, don't erase
C  the screen;  otherwise erase in order to display the help commands.
	        CALL MESSAGE('Help requested')
	        CALL MESSAGE('a = Allows the user to enter annotation at the'//
	1       ' location of the crosshairs')
	        CALL MESSAGE('^A = Prompts user for the height of the '//
	1       'annotation')
	        CALL MESSAGE('    with the color most recently selected')
	        CALL MESSAGE('c = Allows the user to be prompted for the'//
	1       ' color ')
	        CALL MESSAGE('    Initial color is red.  Overlay values are:')
	        CALL MESSAGE('    16777416 = Green')
	        CALL MESSAGE('    16777417 = Black')
	        CALL MESSAGE('    16777418 = White')
	        CALL MESSAGE('    16777419 = Red')
	        CALL MESSAGE('    16777420 = Green')
	        CALL MESSAGE('    16777421 = Blue')
	        CALL MESSAGE('    16777422 = Yellow')
	        CALL MESSAGE('H = Help')
	        CALL MESSAGE('Q = Returns')
	        CALL MESSAGE('V = Draws a solid vector of the color and'//
	1       ' vector style most recently selected')
	      ELSE IF (ICHAR.EQ.86) THEN !  The letter V for vector
	        CALL MESSAGE('Vectors from cursor requested')
	        CALL WHERE(XNOW,YNOW,ICHAR1)
	        CALL WHERE(XNOW1,YNOW1,ICHAR1)
	        CALL PLOT(XNOW-XAXIS_OFFSET,YNOW-YAXIS_OFFSET,3)
	        CALL PLOT(XNOW1-XAXIS_OFFSET,YNOW1-YAXIS_OFFSET,2)
	      END IF
	      CALL WHERE(XNOW,YNOW,ICHAR)
	    END DO

	  ELSE IF (COMMAND.EQ.'B') THEN
	    CALL TVBOX(DATA,MAXSIZE,'SAOimage')
	  ELSE IF (COMMAND.EQ.'C') THEN
C  Read cursor coordinates
	    CALL MESSAGE('Be sure SAOimage has focus, position the cursor,'//
	1   ' then press <CR> or any key')
	    CALL DELAY(1.0)
	    MESSAG=.TRUE.
	    CALL SAO_CURN(NPICN,IXT,IYT,XF,YF,XM,YM,KEY,MESSAG)
	    WRITE (6,1000) NPICN,TV_FILENAME(NPICN)
	    WRITE (7,1000) NPICN,TV_FILENAME(NPICN)
1000	    FORMAT(' ','Cursor in image ',I2';  ','file name = ',A30)
	    WRITE (6,2000) IXT,IYT !  Position on TV
	    WRITE (7,2000) IXT, IYT
2000	    FORMAT(' ',10X,'(X, Y:  on TV desktop)= ',I8,2X,I8)
	    WRITE (6,3000) XF,YF !  Position in frame
	    WRITE (7,3000) XF,YF
3000	    FORMAT(' ',10X,'(X, Y:  in frame     )= ',F8.3,2X,F8.3)
	    WRITE (6,4000) XM,YM !  Position in map
	    WRITE (7,4000) XM,YM
4000	    FORMAT(' ',10X,'(X, Y:  in map       )= ',F8.3,2X,F8.3)
C  Gaussian statistics on an area defined by 2 cursor clicks
	  ELSE IF (COMMAND.EQ.'G') THEN
 	    CALL TV_STATS_SAO
C  Help
	  ELSE IF (COMMAND.EQ.'H') THEN
	    WRITE (6,5000)
	    WRITE (7,5000)
5000	    FORMAT(
	1   /'     A =  Does annotation and drawing (enter H for help)'
	1   /'     B =  Displays positions and values in cursor box area'
	1   /'     C =  Displays complete positions of cursor'
	1   /'     G =  Does gaussian statistics on the cursor box area'
	1   /'     J =  Loads a high contrast spectrum lookup table'
	1   /'     K =  Loads a spectrum lookup table including white'
	1   /'     H =  Displays this list of commands'
	1   /'     P =  Loads the lookup table used for plotting'
	1   /'     Q =  Exits this option'
	1   /'     W =  Loads a black and white triangle look-up table'
	1   /'     X =  Loads a black and white sawtooth look-up table'
C	1   /'     Z =  Sets the color for zero intensity'
	1 )
C  High contrast lookup table
	  ELSE IF (COMMAND.EQ.'J'.OR.COMMAND.EQ.'K'.OR.COMMAND.EQ.'W') THEN
	    IF (COMMAND.EQ.'J') IVAL='900'X
	    IF (COMMAND.EQ.'K') IVAL='A00'X
	    IF (COMMAND.EQ.'W') IVAL='B00'X
	    CALL SAOCONVLT(IVAL)
C  Plotting lookup table
	  ELSE IF (COMMAND.EQ.'P') THEN
	    CALL SAO(0,0,16)
C  Quit
	  ELSE IF (COMMAND.EQ.'Q') THEN
	    GO TO 999
C  Black and white sawtooth look-up table
	  ELSE IF (COMMAND.EQ.'X') THEN
	    DO J=1,10
	      DO I=0,19
	        RED(I+20*(J-1))=I*255/19
	        GREEN(I+20*(J-1))=I*255/19
	        BLUE(I+20*(J-1))=I*255/19
	      END DO
	    END DO
	    CALL SAO_LOAD_VLT(BLUE,GREEN,RED)
C  Set the background color
C	  ELSE IF (COMMAND.EQ.'Z') THEN
C	    ZERO=0
C	    CALL USRINP(ZERO,1,'I',4,1,'ZERO=',
C	1   'Enter the color for zero intensity:  (default = 0)')
C	     RD=IAND(PLT$M_THIRDBYTE,ZERO)/256**2
C	     GRN=IAND(PLT$M_SECONDBYTE,ZERO)/256
C	     BLU=IAND(PLT$M_FIRSTBYTE,ZERO)
C	     CALL SAO_ZERO_VLT(BLU,GRN,RD)
	  END IF
	END DO
C
 999	CONTINUE
C  Erase any cursors that were drawn
	CALL SAO_ERASE_CURSOR(0)
	RETURN
	END
