	SUBROUTINE TVBOX(DATA,MAXSIZE,DISPLAY_DEVICE)
C
C       This subroutine reads pixel values off the disk for a FITS file
C  within an area designated by the TV cursor-box and displays the
C  results on the terminal.  The number of columns is limited to 8
C  but the number of rows is set by the size of the map.
C			Donald H. Gudehus, 1982
C			Version 2, Donald H. Gudehus, November, 1988
C			Added code for Trapix
C			Version 3, Donald H. Gudehus, July, 1993
C			Added argument DISPLAY_DEVICE
C			Version 4, Donald H. Gudehus, February 19, 2008
C			Modified code for FITS, and removed code for
C			Grinnell and Trapix.
C		
C
C	DATA	(C)		A working array
C	MAXSIZE	(C)		The passed length for the size of DATA
C	DISPLAY_DEVICE	(C)	The display device to be used.  The 
C				possibilities are GRINNELL_270, TRAPIX,
C				and SAOimage.
C
	INCLUDE 'fitsfacts.for'
	INCLUDE 'saofacts.for'
C
	CHARACTER*(*) DISPLAY_DEVICE
	REAL*4 DATA(MAXSIZE),VALUE(8)
C
C
	CHARACTER*40 FILEKEYWORD
	CHARACTER*80 FILENAME
C
	INTEGER*2 NX1,NX2,NY1,NY2,NPTX,NPTY,NX,NY,
	1IX(5),IY(5)
C
	INTEGER*4 ICOLUMN(8),STATUS
C
	LOGICAL IOFL
C
	REAL INCLINA
C
	CHARACTER*1 CHAR
	CHARACTER*80 DNAME
	COMMON /DFILE/ DNAME
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
C  Read the cursors' positions
C
	IF (DISPLAY_DEVICE.EQ.'SAOimage') THEN
	  MODE=2 !  Updates DNAME if a new image is chosen
	  CALL SAO2CUR(MODE,IX1,IY1,IX2,IY2,X1,Y1,X2,Y2,XM1,YM1,XM2,YM2,
	1 NPIC1,KEY,X,Y,a,b)
	ELSE
	  CALL ERROR(-1,'No display device is available for TVBOX')
	END IF
	XPOS2=AMAX1(XM1,XM2)
	IF (XM2.EQ.XPOS2) THEN
	  XPOS1=XM1
	ELSE
	  XPOS1=XM2
	END IF
	YPOS2=AMAX1(YM1,YM2) 
	IF (YM2.EQ.YPOS2) THEN
	  YPOS1=YM1
	ELSE
	  YPOS1=YM2
	END IF
	ILO=XPOS1
	IHI=XPOS2
	JLO=YPOS1
	JHI=YPOS2
	NPTSX=IHI-ILO+1
	NELM=6
	IF (NELM.GT.NPTSX) NELM=NPTSX
C  Open the disk file for reading
	CALL GET_LU_FROM_SAO(LU_IN,NPIC1,STATUS)
	IF (STATUS.NE.0) RETURN
	DO I=1,NELM
	  ICOLUMN(I)=ILO+I-1
	END DO
	CALL MESSAGE(' ')
	WRITE(6,1011) (ICOLUMN(II),II=1,NELM)
1011	FORMAT(' ','Column #',<NELM>(I4,8X))
	WRITE(7,1011) (ICOLUMN(II),II=1,NELM)
	WRITE(6,1010)
1010	FORMAT(' ','Row #','                  Pixel values ')
	WRITE(7,1010)
	DO J=JLO,JHI
	  CALL RDFITSROW(LU_IN,IMNUM,IPNUM,DATA,NCOLS,J)
	  DO I=1,NELM
	    VALUE(I) = DATA(ILO+I-1)
	  END DO
	  WRITE(6,1012) J,(VALUE(II),II=1,NELM)
1012	  FORMAT(' ',1I4,1X,<NELM>G12.5)
	  WRITE(7,1012) J,(VALUE(II),II=1,NELM)
	  CALL MESSAGE(' ')
	END DO
	CALL CLOSEFITS(LU_IN)
C  Erase any cursors that were drawn
C	IF (DISPLAY_DEVICE.EQ.'SAOimage') CALL SAO_ERASE_CURSOR(0)
	RETURN
	END
