	SUBROUTINE NOISE
C
C       This subroutine produces three kinds of noise (readout, shot,
C  and spatial) which are then inserted into either a FITS file or a data
C  file of the type prepared by options EA, FG, or PR
C		Donald H. Gudehus, March 3, l983
C		Version 2, Donald H. Gudehus, April 21, 1987
C		Added transfer and trapping noise.
C		Version 2U, Donald H. Gudehus, January 26, 2008
C		Converted to Unix
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
C
	CHARACTER*3 PRGFMAT
        CHARACTER*40 FILEKEYWORD
	CHARACTER*80 FILENAME
C
	INTEGER PLANEKEY,STATUS,LX,NF,NR,NPTS
C
	REAL*4 DATA(MAXSIZE)
	REAL*4 PARAM_PRF(MAXSIZE,7)
	REAL*4 INDEXMINUSRADIUS,GAIN,READOUT,TRANSTRAP,SPATIAL,SPATIAL100,
	1SQRTGAIN,SUM,PI,DELTARAD
	COMMON /REAL4_SCRATCH_BLOCK/ DATA,PARAM_PRF,INDEXMINUSRADIUS,GAIN,
	1READOUT,TRANSTRAP,SPATIAL,SPATIAL100,SQRTGAIN,SUM,PI,DELTARAD
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	LOGICAL OFIL
	COMMON /OLDFILE/ OFIL
C
	CHARACTER*1 COMMAND
	CHARACTER*6 IDREAD
	COMMON /CHAR_SCRATCH_BLOCK/ COMMAND,IDREAD
C
	CHARACTER*6 ID
	COMMON /ID/ ID
C
	PI=3.14159265
	CALL MESSAGE ('NOISE, Version 2')
	COMMAND='F'
	CALL MESSAGE('Enter a command:     D = Data file')
	CALL USRINP(%REF(COMMAND),1,'A',1,1,'COMMAND=',
	1'                     F = FITS file (default)')
	CALL MESSAGE('Open the file to have noise introduced')
	IF (COMMAND.EQ.'D') THEN
	  CALL OPENCF(21,1,'FILE_21=',0)
	  CALL USRINP(%REF(ID),1,'A',6,1,'ID=',
	1 'Enter the ID of the object:  (default = last entry)')
	  CALL ALPHA(%REF(ID),1,6,LX,NF,NR,2)
	ELSE
	  LU_IN=11
	  FILEKEYWORD='FILE='
	  FILENAME=' '
	  IOFL=.FALSE.
	  MAPKEY=0
	  PLANEKEY=0
	  NMAPS=0
	  NPLNS=0
	  NROWS=0
	  NCOLS=0
	  PRGFMAT=' '
	  CALL OPENFITS(LU_IN,IOFL,FILEKEYWORD,FILENAME,MAPKEY,PLANEKEY,NMAPS,
	1 NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	END IF
	GAIN=1.0
	CALL USRINP(GAIN,1,'F',4,1,'GAIN=',
	1'Enter the gain of system in electrons per ADU:'//
	2'  (default = 1)')
	SQRTGAIN=SQRT(GAIN)
	READOUT=0.0
	CALL USRINP(READOUT,1,'F',4,1,'READOUT_NOISE=',
	1'Enter the readout noise in ADU:  (default = 0)')
	IF (COMMAND.EQ.'F') THEN
	  TRANSTRAP=0.0
	  CALL MESSAGE('Enter the transfer and trapping noise expressed'//
	1 ' as a percent of the')
	  CALL USRINP(TRANSTRAP,1,'F',4,1,'TRANSFER_TRAPPING=',
	1 'shot noise at the center of the field:  (default = 0)')
	  TRANSTRAP=TRANSTRAP/100.0/(SQRT(NCOLS/2.0+NROWS/2.0*NCOLS))
	END IF
	SPATIAL=0.0
	CALL USRINP(SPATIAL100,1,'F',4,1,'SPATIAL_NOISE=',
	1'Enter the spatial noise as a percent:  (default = 0)')
	SPATIAL=SPATIAL100/100.0
	ISEED=12345
	CALL USRINP(ISEED,1,'I',4,1,'SEED=',
	1'Enter the seed for the random number generator:'//
	2'  (default = 12345)')
	IF (COMMAND.EQ.'D') THEN
	  CALL RDDATFL1(21,ID,PARAM_PRF,MAXSIZE,NPTS,
	1 INDEXMINUSRADIUS,DELTARAD)
C  Open the output file
	  CALL OPENCF(22,0,'FILE_22=',0)
	  IF (.NOT.OFIL) THEN
	    WRITE(22,1100)
1100	    FORMAT(' ','ID',8X,'COLUMN',5X,'ROW',1X,'INCLINATION',
	1   1X,'ECCENTRICITY',1X,'RADIUS',5X,'ADU',3X,'LOG(INTEGRAL)')
	  END IF
	  DO N=1,NPTS
	    IF (READOUT.GT.0.) THEN
	      SUM=0.0
	      DO K=1,12
	        SUM=SUM+RAN(ISEED)
	      END DO
	      PARAM_PRF(N,6)=PARAM_PRF(N,6)+READOUT*(SUM-6.0)/
	1     MAX(1.0,SQRT(2.0*PI*PARAM_PRF(N,5)))
	    END IF
	    IF (GAIN.GT.0.) THEN
	      SUM=0.0
	      DO  K=1,12
	        SUM=SUM+RAN(ISEED)
	      END DO
	      PARAM_PRF(N,6)=PARAM_PRF(N,6)+SQRT(ABS(PARAM_PRF(N,6)))*
	1     (SUM-6.0)/SQRTGAIN/
	2     MAX(1.0,SQRT(2.0*PI*PARAM_PRF(N,5)))
	    END IF
	    IF (SPATIAL.GT.0.0) THEN
	      SUM=0.0
	      DO K=1,12
	        SUM=SUM+RAN(ISEED)
	      END DO
	      PARAM_PRF(N,6)=PARAM_PRF(N,6)+PARAM_PRF(N,6)*SPATIAL*
	1     (SUM-6.0)/
	2     MAX(1.0,SQRT(2.0*PI*PARAM_PRF(N,5)))
	    END IF
	    WRITE (22,1101) ID,(PARAM_PRF(N,IPARAM),IPARAM=1,7)
1101	    FORMAT(' ',A6,1X,F9.3,1X,F9.3,1X,F7.2,6X,F6.3,F8.3,1X,
	1   F13.6,1X,F11.8)
	  END DO  
	  CLOSE (21)
	  CLOSE (22) 
	ELSE IF (COMMAND.EQ.'F') THEN
	  DO J=1,NROWS
	    CALL RDFITSROW(LU_IN,IMNUM,IPNUM,DATA,MAXSIZE,J)
	    DO I=1,NCOLS
	      IF (READOUT.GT.0.) THEN
	        SUM=0.0
	        DO K=1,12
	          SUM=SUM+RAN(ISEED)
	        END DO
	        DATA(I)=DATA(I)+READOUT*(SUM-6.0)
	      END IF
	      IF (GAIN.GT.0.) THEN
	        SUM=0.0
	        DO  K=1,12
	          SUM=SUM+RAN(ISEED)
	        END DO
	        DATA(I)=DATA(I)+SQRT(ABS(DATA(I)))*(SUM-6.0)/SQRTGAIN
	      END IF
	      IF (TRANSTRAP.GT.0) THEN
C  This noise will be highest in the lower right
	        SUM=0.0
	        DO  K=1,12
	          SUM=SUM+RAN(ISEED)
	        END DO
	        DATA(I)=DATA(I)+SQRT(ABS(DATA(I)))*(SUM-6.0)/SQRTGAIN*
	1       SQRT(FLOAT(I+(NROWS-J)*NCOLS))*TRANSTRAP
	      END IF
	      IF (SPATIAL.GT.0.) THEN
	        SUM=0.0
	        DO K=1,12
	          SUM=SUM+RAN(ISEED)
	        END DO
	        DATA(I)=DATA(I)+DATA(I)*SPATIAL*(SUM-6.0)
	      END IF
	    END DO
	    CALL WRFITSROW(LU_IN,IMNUM,IPNUM,DATA,MAXSIZE,J)
	  END DO
	  CALL CLOSEFITS(LU_IN)
	END IF
	RETURN
	END
