	SUBROUTINE PRINTERM
C
C       This subroutine prints the pixel values from an xy
C  area, on the terminal.  The boundaies can be input by
C  the TV cursor box or manually.
C			Donald H. Gudehus, January 29, 2008
C
	INCLUDE 'miipspar.for'
	INCLUDE 'fitsfacts.for'
	INCLUDE 'saofacts.for'
C
	CHARACTER*2 COMMAND
	CHARACTER*3 PRGFMAT,FILEFMT
	CHARACTER*40 FILEKEYWORD
	CHARACTER*50 CHFITSMHV
	CHARACTER*80 FILENAME_IN
C
	INTEGER*2 IX1,IY1,IX2,IY2
	INTEGER IXM1,IYM1,IXM2,IYM2
	INTEGER PLANEKEY,STATUS,ISZ(4)
	INTEGER ACTION,CURSOR_TYPE,COLOR_TYPE
C
	LOGICAL IOFL,PROCEED
C
	REAL*4 DATAXY(MAXSIZE,MAXSIZE),INCLINA
C
	COMMON /REAL4_SCRATCH_BLOCK/ DATAXY
C
	REAL*8 DATADPXY(MAXSIZE,MAXSIZE)
C
	COMMON /REAL8_SCRATCH_BLOCK/ DATADPXY
C
	LOGICAL GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	COMMON /DISPLAY_AVAILABILITY/ GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
C
	CHARACTER*80 DNAME
	LOGICAL EXTENDED
	COMMON /DFILE/ DNAME,EXTENDED
C
	COMMON /MAPN/ IMNUM
	COMMON /PLANEN/ IPNUM
C
	CALL MESSAGE ('PRINTERM, Version 1')
C  Initialize XM1 to avoid quitting subroutine
	XM1=1.0
	LU_IN=11
	FILEKEYWORD='FILE='
	FILENAME_IN=' '
	IOFL=.TRUE.
	MAPKEY=0
	PLANEKEY=0
	NMAPS=0
	NPLNS=0
	NROWS=0
	NCOLS=0
	PRGFMAT=' '
	CALL OPENFITS(LU_IN,IOFL,FILEKEYWORD,FILENAME_IN,MAPKEY,PLANEKEY,NMAPS,
	1NPLNS,NCOLS,NROWS,PRGFMAT,STATUS)
	COMMAND=' '
C  Create a temporary file.
	LU_TEMP=12
	NMAPS_IN=1
C
	COMMAND=' '
	DO WHILE (COMMAND.NE.'AS'.AND.COMMAND.NE.'S'
	1.AND.COMMAND.NE.'M')
	  CALL MESSAGE('Enter a command:')
	  COMMAND='M'
	  IF (SAOIMAGE) THEN
	    CALL MESSAGE('     AS = Position from cursor;  SAOimage '//
	1   'already loaded')
	    CALL MESSAGE('      S = Position from cursor;  need to '//
	1   'load SAOimage')
	  END IF
	  CALL MESSAGE('      M = Manual input of boundaries (default)')
	  CALL USRINP(%REF(COMMAND),1,'A',2,1,'COMMAND=',' ')
	  CALL ALPHA(%REF(COMMAND),1,2,NC,NF,NR,2)
	END DO
	IF (COMMAND.EQ.'S') THEN
	  NPIC_SAO=1
	  IF (IFB_SAO.EQ.0) THEN
	    CALL SAOSTART
	    CALL SAOFIRST
	  ELSE
	    CALL SAOERAS
	  END IF
	  CALL SAODELS(LU_IN,1,0)
	END IF
	DO WHILE (.TRUE.) !  Main loop
	  IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	    PROCEED=.FALSE.
	    DO WHILE (.NOT.PROCEED)
	      MODE=1 !  Gives prompt for quiting
	      CALL SAO2CUR(MODE,IX1,IY1,IX2,IY2,X1,Y1,X2,Y2,XM1,YM1,XM2,YM2,
	1     NPIC1,KEY,X,Y,a,b)
	      IF (KEY.EQ.48.OR.KEY.EQ.81) GO TO 999 !  User instigated quit
	      PROCEED=.TRUE.
	      CALL USRINP(PROCEED,1,'L',1,1,'PROCEED=',
	1     'Do you wish to proceed?  (default = Y)')
	      IF (PROCEED) THEN
C  Erase the red box so that the yellow one will appear
	        CALL SAO_ERASE_CURSOR(0)
C  Write vectors onto SAOimage (not erasable)
	        ACTION=2  ! Non erasable cursor
	        CURSOR_TYPE=768  ! Rectangle
	        COLOR_TYPE=207  ! Yellow
	        CALL SAO_DRAW(ACTION,CURSOR_TYPE,COLOR_TYPE,X,Y,NPIC1,
	1       a,b,INCLINA,EXTRA,0)
	      ELSE IF (.NOT.PROCEED) THEN
C  Erase rectangle cursor
	        CALL SAO_ERASE_CURSOR(0)
	      END IF 
	    END DO
	  ELSE IF (COMMAND.EQ.'M') THEN
	    CALL USRINP(ISZ,4,'I',4,0,'BOUNDARIES=',
	1   'Enter start-column end-column start-row end-row:  '//
	2   '(enter 0 to quit)')
	    XM1=ISZ(1)
	    XM2=ISZ(2)
	    YM1=ISZ(3)
	    YM2=ISZ(4)
	    IF (XM1.EQ.0) GO TO 999
	  END IF
	  IXM1=INT(XM1)
	  IXM2=INT(XM2)
	  IYM1=INT(YM1)
	  IYM2=INT(YM2)
	  NX=IXM2-IXM1+1
	  NY=IYM2-IYM1+1
	  FILEFMT=CHFITSMHV(LU_IN,IMNUM,'BITPIX','R4')
	  IF (FILEFMT.EQ.'I1'.OR.FILEFMT.EQ.'I2'.OR.FILEFMT.EQ.'I4'.OR.
	1 FILEFMT.EQ.'R4'.OR.FILEFMT.EQ.'C8') THEN
	    CALL RDFITSXY(LU_IN,IMNUM,IPNUM,DATAXY,MAXSIZE,MAXSIZE,
	1   IXM1,NX,IYM1,NY)
	    DO J=1,NY
	      WRITE (6,1015) IXM1+J-1
1015	      FORMAT(' ','ROW =',I5)
	      WRITE (7,1015) IXM1+J-1
	      DO I=1,NX
	        WRITE (6,1020) IXM1+I-1,DATAXY(I,J)
1020	        FORMAT(' ','COLUMN =',I5,4X,'VALUE = ',G15.7)
	        WRITE (7,1020) IXM1+I-1,DATAXY(I,J)
	      END DO
	    END DO
	  ELSE IF (FILEFMT.EQ.'R8'.OR.FILEFMT.EQ.'C16') THEN
	    CALL RDDPFITSXY(LU_IN,IMNUM,IPNUM,DATAXY,MAXSIZE,MAXSIZE,
	1   IXM1,NX,IYM1,NY)
	    DO J=1,NY
	      WRITE (6,1015) IXM1+J-1
	      WRITE (7,1015) IXM1+J-1
	      DO I=1,NX
	        WRITE (6,1030) IXM1+I-1,DATADPXY(I,J)
1030	        FORMAT(' ','COLUMN =',I5,4X,'VALUE = ',G25.16)
	        WRITE (7,1030) IXM1+I-1,DATADPXY(I,J)
	      END DO
	    END DO
	  END IF
	END DO
C  If SAOimge was used, erase the cursor (the drawing can't be erased).
 999	IF (COMMAND.EQ.'AS'.OR.COMMAND.EQ.'S') THEN
	  CALL SAO_ERASE_CURSOR(0)
	END IF
	CALL CLOSEFITS(LU_IN)
	RETURN
	END
