	SUBROUTINE TV
C
C       This subroutine selects the proper image display subroutine to call,
C  based on the names of the display devices available.
C			Donald H. Gudehus, October 3, 1988
C			Version 2, Donald H. Gudehus, July, 1993
C			Added code for RAM_IMAGPROC
C			Version 3, Donald H. Gudehus, August, 1993
C			Added code for SAOimage
C			Version 3U, Donald H. Gudehus, January 29, 2008
C			Modified code for Unix and FITS
C
	CHARACTER CHOICE*1
	LOGICAL GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
	COMMON /DISPLAY_AVAILABILITY/ GRINNELL_270,TRAPIX,RAMTEK,SAOIMAGE
C
	CALL MESSAGE('TV, Version 3')
	IF (.NOT.GRINNELL_270.AND..NOT.TRAPIX.AND..NOT.RAMTEK.AND..NOT.
	1SAOIMAGE) THEN
	  CALL MESSAGE('Sorry, no display device is available at your site')
	  RETURN
	END IF
C  If only one device is available, don't ask any questions
	IF (GRINNELL_270.AND..NOT.(TRAPIX.OR.RAMTEK.OR.SAOIMAGE)) THEN
	  CHOICE='G'
	ELSE IF (TRAPIX.AND..NOT.(GRINNELL_270.OR.RAMTEK.OR.SAOIMAGE)) THEN
	  CHOICE='T'
	ELSE IF (RAMTEK.AND..NOT.(GRINNELL_270.OR.TRAPIX.OR.SAOIMAGE)) THEN
	  CHOICE='R'
	ELSE IF (SAOIMAGE.AND..NOT.(GRINNELL_270.OR.TRAPIX.OR.RAMTEK)) THEN
	  CHOICE='S'
	ELSE  ! 2 or more display devices available
	  CHOICE=' '
	  DO WHILE(CHOICE.NE.'G'.AND.CHOICE.NE.'T'.AND.CHOICE.NE.'R'
	1 .AND.CHOICE.NE.'S')
	    CALL MESSAGE('Enter a choice:')
	    IF (GRINNELL_270) THEN
	      CALL MESSAGE('            G = Image display with Grinnell')
	    END IF
	    IF (TRAPIX) THEN
	      CALL MESSAGE('            T = Image display with Trapix')
	    END IF
	    IF (RAMTEK) THEN
	      CALL MESSAGE('            R = Image display with Ramtek')
	    END IF
	    IF (SAOIMAGE) THEN
	      CALL MESSAGE('            S = Image display with SAOimage')
	    END IF
	    CALL USRINP(%REF(CHOICE),1,'A',1,0,'CHOICE=',' ')
	    CALL ALPHA(%REF(CHOICE),1,1,NC,NF,NR,2)
	  END DO
	END IF
C	IF (CHOICE.EQ.'G') CALL GR_TV
C	IF (CHOICE.EQ.'T') CALL TR_TV
C	IF (CHOICE.EQ.'R') CALL RAM_TV
	IF (CHOICE.EQ.'S') CALL SAO_TV
	RETURN
	END
